React Authentication By Example: Using React Router 6
The React examples on this guide apply to React v18+
and React Router v6
. These examples help you learn the following security concepts:
- How to add user login, sign-up, and logout to React applications.
- How to use the new React Router
v6
features to create route guards that protect React application routes. - How to make API calls from React to request data from a protected API.
- How to get user profile information to personalize a React user interface.
This guide uses the Auth0 React SDK, which provides developers with a high-level API to handle many user authentication implementation details. You can now secure your React applications following security best practices while writing less code.
v5
with Auth0 to protect React applications, follow the "React Authentication By Example: Using React Router 5" guide.Quick React Setup
With the help of Auth0, you don't need to be an expert on identity protocols, such as OAuth 2.0 or OpenID Connect, to understand how to secure your web application stack.
You first integrate your React application with Auth0. Your application will then redirect users to an Auth0 customizable login page when they need to log in. Once your users log in successfully, Auth0 redirects them back to your React app, returning JSON Web Tokens (JWTs) with their authentication and user information.
Get the React Starter Application
We have created a starter project using create-react-app
to help you learn React security concepts through hands-on practice. You can focus on building React components and JavaScript services to secure your application.
Start by cloning the spa_react_javascript_hello-world_react-router-6
repository on its starter
branch:
git clone -b starter [email protected]:auth0-developer-hub/spa_react_javascript_hello-world.git
Once you clone the repo, make spa_react_javascript_hello-world_react-router-6
your current directory:
cd spa_react_javascript_hello-world
Install the React project dependencies as follows:
npm install
This starter React project offers a functional application that consumes data from an external API to hydrate the user interface. For simplicity and convenience, the starter project simulates the external API locally using json-server
. Later on, you'll integrate this React application with a real API server using a backend technology of your choice.
The compatible API server runs on http://localhost:6060
by default. As such, to connect your React application with that API server, create a .env
file under the root project directory:
touch .env
Populate it with the following environment variables:
REACT_APP_API_SERVER_URL=http://localhost:6060
Keep in mind that a React project generated using create-react-app
application will only expose environment variables from .env
to your processed code if those variables are prefixed with REACT_APP_
. This practice helps you prevent accidentally leaking your system's environment variables to your client application.
Next, execute the following command to run the JSON server API:
npm run api
Finally, open another terminal tab and execute this command to run your React application:
npm start
You are ready to start implementing user authentication in this React project. First, you'll need to configure the React application to connect successfully to Auth0. Afterward, you'll use the Auth0 React SDK to log in users, protect routes, display user profile information, and request protected data from an external API server to hydrate some of the application pages.
Configure React with Auth0
Follow these steps to get started with the Auth0 Identity Platform quickly:
Sign up and create an Auth0 Application
A free account also offers you:
- Auth0 Universal Login for Web, iOS & Android.
- Up to 2 social identity providers like Google, GitHub, and Twitter.
- Up to 3 Actions, Rules, & Hooks to customize and extend Auth0's capabilities.
During the sign-up process, you create something called an Auth0 Tenant, representing the product or service to which you are adding authentication.
Once you sign in, Auth0 takes you to the Dashboard. In the left sidebar menu, click on "Applications".
Then, click the "Create Application" button. A modal opens up with a form to provide a name for the application and choose its type. Use the following values:
Auth0 React Code Sample
Click the "Create" button to complete the process. Your Auth0 application page loads up.
In the next step, you'll learn how to help React and Auth0 communicate.
What's the relationship between Auth0 Tenants and Auth0 Applications?
Let's say that you have a photo-sharing React app called "Reactigram". You then would create an Auth0 tenant called reactigram
. From a customer perspective, Reactigram is that customer's product or service.
Now, say that Reactigram is available on three platforms: web as a single-page application and Android and iOS as a native mobile application. If each platform needs authentication, you need to create three Auth0 applications to provide the product with everything it needs to authenticate users through that platform.
Reactigram users belong to the Auth0 Reactigram tenant, which shares them across its Auth0 applications.
Create a communication bridge between React and Auth0
When using the Auth0 Identity Platform, you don't have to build login forms. Auth0 offers a Universal Login Page to reduce the overhead of adding and managing authentication.
How does Universal Login work?
Your React application will redirect users to Auth0 whenever they trigger an authentication request. Auth0 will present them with a login page. Once they log in, Auth0 will redirect them back to your React application. For that redirecting to happen securely, you must specify in your Auth0 Application Settings the URLs to which Auth0 can redirect users once it authenticates them.
As such, click on the "Settings" tab of your Auth0 Application page, locate the "Application URIs" section, and fill in the following values:
http://localhost:4040/callback
The above value is the URL that Auth0 can use to redirect your users after they successfully log in.
http://localhost:4040
The above value is the URL that Auth0 can use to redirect your users after they log out.
http://localhost:4040
Using the Auth0 React SDK, your React application will make requests under the hood to an Auth0 URL to handle authentication requests. As such, you need to add your React application origin URL to avoid Cross-Origin Resource Sharing (CORS) issues.
Scroll down and click the "Save Changes" button.
Do not close this page yet. You'll need some of its information in the next section.
Add the Auth0 configuration variables to React
From the Auth0 Application Settings page, you need the Auth0 Domain and Client ID values to allow your React application to use the communication bridge you created.
What exactly is an Auth0 Domain and an Auth0 Client ID?
Domain
When you created a new Auth0 account, Auth0 asked you to pick a name for your tenant. This name, appended with auth0.com
, is your Auth0 Domain. It's the base URL that you will use to access the Auth0 APIs and the URL where you'll redirect users to log in.
Client ID
Each application is assigned a Client ID upon creation, which is an alphanumeric string, and it's the unique identifier for your application (such as q8fij2iug0CmgPLfTfG1tZGdTQyGaTUA
). You cannot modify the Client ID. You will use the Client ID to identify the Auth0 Application to which the Auth0 SPA SDK needs to connect.
Warning: Another critical piece of information present in the "Settings" is the Client Secret. This secret protects your resources by only granting tokens to requestors if they're authorized. Think of it as your application's password, which must be kept confidential at all times. If anyone gains access to your Client Secret, they can impersonate your application and access protected resources.
Head back to your Auth0 application page and click on the "Settings" tab.
Locate the "Basic Information" section and follow these steps to get the Auth0 Domain and Auth0 Client ID values:
When you enter a value in the input fields present on this page, any code snippet that uses such value updates to reflect it. Using the input fields makes it easy to copy and paste code as you follow along.
As such, enter the "Domain" and "Client ID" values in the following fields to set up your single-page application in the next section:
These variables let your React application identify itself as an authorized party to interact with the Auth0 authentication server.
Now, update the .env
file under the React project directory as follows:
REACT_APP_API_SERVER_URL=http://localhost:6060REACT_APP_AUTH0_DOMAIN=AUTH0-DOMAINREACT_APP_AUTH0_CLIENT_ID=AUTH0-CLIENT-IDREACT_APP_AUTH0_CALLBACK_URL=http://localhost:4040/callback
Restart your development server for your React project to become aware of these .env
file changes:
npm start
Once you reach the "Call a Protected API from React" section of this guide, you'll learn how to use REACT_APP_API_SERVER_URL
along with an Auth0 Audience value to request protected resources from an external API that is also protected by Auth0. For now, the application is using json-server
to mock the API.
Handle the Auth0 post-login behavior
Notice that the Auth0 Callback URL, REACT_APP_AUTH0_CALLBACK_URL
, points to http://localhost:4040/callback
, which is the URL that Auth0 uses to redirect your users after they successfully log in. For this React application, you'll render a simple page component for the /callback
route.
Create a callback-page.js
file under the src/pages
directory:
touch src/pages/callback-page.js
Populate src/pages/callback-page.js
with the following code:
import React from "react";import { NavBar } from "../components/navigation/desktop/nav-bar";import { MobileNavBar } from "../components/navigation/mobile/mobile-nav-bar";export const CallbackPage = () => {return (<div className="page-layout"><NavBar /><MobileNavBar /><div className="page-layout__content" /></div>);};
The callback-page.js
component will only render the navigation bar and an empty content container to help you create a smooth transition between a route with no content, /callback
, to a route with content, such as the /profile
page.
The next step is to integrate your callback-page.js
component with the React Router.
Locate the src/app.js
file, which defines your React application routes using the <Routes>
and <Route>
components from React Router v6
, and update it like so:
import React from "react";import { Route, Routes } from "react-router-dom";import { AdminPage } from "./pages/admin-page";import { CallbackPage } from "./pages/callback-page";import { HomePage } from "./pages/home-page";import { NotFoundPage } from "./pages/not-found-page";import { ProfilePage } from "./pages/profile-page";import { ProtectedPage } from "./pages/protected-page";import { PublicPage } from "./pages/public-page";export const App = () => {return (<Routes><Route path="/" element={<HomePage />} /><Route path="/profile" element={<ProfilePage />} /><Route path="/public" element={<PublicPage />} /><Route path="/protected" element={<ProtectedPage />} /><Route path="/admin" element={<AdminPage />} /><Route path="/callback" element={<CallbackPage />} /><Route path="*" element={<NotFoundPage />} /></Routes>);};
What are the benefits of using a callback page?
Implementing a page that specializes in handling the user redirection from the Auth0 Universal Login Page to your application (the callback event) has some benefits:
- Your users won't see any flashing of the home page component, which renders at the root path,
/
. - By showing the navigation bar in the
/callback
route, your user may feel that your React application loads fast. - By not showing the footer, your users may feel that your React application loads smoothly.
- If you were to render the footer component, your application may appear to be jumpy as the footer may show up briefly but then it would be pushed down when the content above it loads.
- You can avoid making unnecessary or costly API calls that may run when loading your home page components.
Once you add a login and logout button to this app, you can verify this user experience improvement by using your browser's developer tools. In the case of Google Chrome, you could do the following:
-
Configure Chrome to emulate slow network connections to observe how the application loads after logging in.
-
Record the runtime performance of your React application. Once done, observe the rendering order of pages and elements in the timeline Chrome produces.
If you are not convinced yet, let's explore more details on the impact of this strategy.
Imagine that you want to redirect your users to the /profile
after they log in. If you were to use the root URL of your React application, http://localhost:4040
, as the Auth0 Callback URL, you may hurt the user experience when the user's connection is slow or when you are lazy loading the /profile
route:
- This React application offers a
/profile
page that will display user profile information such as name and email address. - Since user profile information is private, it must be protected against unauthorized access.
- The Auth0 React SDK allows you to easily require users to log in before they can access a route.
- When a user who is not logged in clicks on the
/profile
page navigation tab, Auth0 will redirect them to a page to log in. - Once your users log in, Auth0 will redirect them to your React application with some metadata that allows your application to redirect them to the protected page they intended to access.
- When you use
http://localhost:4040
as the Auth0 Callback URL, Auth0 will redirect your users to the home page first. Depending on how fast your application renders pages and handles redirects, your users may see the home page first before React takes them to the/profile
page when the connection is slow or when you are lazy loading that route. This quick re-routing makes your user interface "flash", which makes the user interface feel janky or glitchy. - However, when you use
http://localhost:4040/callback
as the Auth0 Callback URL, Auth0 will take your users to a/callback
route after they log in. You can then display a loading animation or nothing at all in that special route. Doing so makes the transition from/callback
to/profile
smoother as no unrelated or unexpected content shows up in the process.
Additionally, when you load the home page, /
, you may trigger logic that fetches data from an external API or runs any other business logic related to hydrating the home page. If your intention is to show the users a /profile
page after they log in, there's no need or value to run any of that home page business logic that won't impact the rendering of the /profile
page. Instead, you may increase your operational costs by running unnecessary logic when any of your users log in. In that case, it's better to handle the Auth0 redirect in a minimal and performant specialized route, /callback
.
Configure a React Authentication Provider
Execute the following command to install the Auth0 React SDK:
npm install @auth0/auth0-react
Under the hood, the Auth0 React SDK uses React Context. The SDK uses an Auth0Context
component to manage the authentication state of your users. In turn, the SDK exposes the Auth0Provider
component that provides that Auth0Context
to its child components. As such, you can wrap your root component, such as App
, with Auth0Provider
to integrate Auth0 with your React app:
<Auth0Provider><App /></Auth0Provider>
However, user authentication is a mechanism to control who can access your application. You can integrate your application with Auth0 to prevent users who have not logged in from accessing a /profile
or /admin
route.
If users want to access a guarded route from your application, Auth0 will stop them and ask them to present their credentials. If Auth0 can verify who they are and that they are supposed to go in there, Auth0 will let them in.
The authentication process won't happen within your React application layer when using Auth0. Your React application will redirect your users to the Auth0 Universal Login page, where Auth0 asks for credentials and redirects the user back to your application with the result of the authentication process.
The Auth0Provider
from the Auth0 React SDK remembers the route the user wanted to access and, if authentication were successful, it takes the user to that route. As such, the Auth0Provider
needs to have access to the session history of the application. The starter React app uses React Router v6
to manage its routing. React Router v6
exposes a React Hook that makes it easy for you to access the session history through a history
object, useNavigate()
.
v6
, the useNavigate()
hook replaces the useHistory()
hook from React Router v5
to access the session history. Visit the "Use useNavigate
instead of useHistory
" document for more details.Consequently, you need to wrap the Auth0Provider
with BrowserRouter
from React Router, which uses a RouterContext.Provider
component under the hood to maintain the routing state:
<BrowserRouter><Auth0Provider><App /></Auth0Provider></BrowserRouter>
Here, what you see at play is a pillar of React's architecture: you extend components, not through inheritance but composition.
How do you create an Auth0Provider
with access to the application session history?
Create an auth0-provider-with-navigate.js
file under the src
directory to define an Auth0ProviderWithNavigate
component, which uses composition to make React Router Hooks available to Auth0Provider
:
touch src/auth0-provider-with-navigate.js
Populate src/auth0-provider-with-navigate.js
with the following:
import { Auth0Provider } from "@auth0/auth0-react";import React from "react";import { useNavigate } from "react-router-dom";export const Auth0ProviderWithNavigate = ({ children }) => {const navigate = useNavigate();const domain = process.env.REACT_APP_AUTH0_DOMAIN;const clientId = process.env.REACT_APP_AUTH0_CLIENT_ID;const redirectUri = process.env.REACT_APP_AUTH0_CALLBACK_URL;const onRedirectCallback = (appState) => {navigate(appState?.returnTo || window.location.pathname);};if (!(domain && clientId && redirectUri)) {return null;}return (<Auth0Providerdomain={domain}clientId={clientId}authorizationParams={{redirect_uri: redirectUri,}}onRedirectCallback={onRedirectCallback}>{children}</Auth0Provider>);};
What is happening within Auth0ProviderWithNavigate
?
- You need the Auth0 React SDK to connect with the correct Auth0 Application to process authentication. As such, you need to configure the
Auth0Provider
to use the Auth0 Domain and Client ID. - You use the
authorizationParams
configuration object to define the query parameters that will be sent during the call to the Auth0/authorize
endpoint. As such, you're passing here theredirect_uri
, which is the URL where Auth0 will redirect your users back to your React application. - You use the
onRedirectCallback()
method to handle the event where Auth0 redirects your users from the Auth0 Universal Login page to your React application.- You use the
useNavigate()
hook to get thehistory
object from React Router. You use thenavigate()
method to take users back to the route they intended to access before authentication. - In the next sections of this guide, you'll create login and sign-up buttons that define the value of the
appState.returnTo
property. You'll customize the behavior of the user login experience by specifying to what route React should take your users after they authenticate with Auth0.
- You use the
That's it! Wrapping any component tree with Auth0ProviderWithNavigate
will give it access to the Auth0Context
.
How do you use Auth0ProviderWithNavigate
?
The Auth0ProviderWithNavigate
requires the BrowserRouter
component from React Router to be its parent, grandparent, or great-great-great-grandparent.
The Context
from React Router must be present in the component tree at a higher level for Auth0ProviderWithNavigate
to access the useNavigate()
hook from React Router.
Open src/index.js
and update it as follows to build the proper component tree to power the routing and user authentication features of your React application:
import React from "react";import { createRoot } from "react-dom/client";import { BrowserRouter } from "react-router-dom";import { App } from "./app";import { Auth0ProviderWithNavigate } from "./auth0-provider-with-navigate";import "./styles/styles.css";const container = document.getElementById("root");const root = createRoot(container);root.render(<React.StrictMode><BrowserRouter><Auth0ProviderWithNavigate><App /></Auth0ProviderWithNavigate></BrowserRouter></React.StrictMode>);
v18
, learn more about how the new root
API works by reading the "Updates to Client Rendering APIs" document.In the next sections, you'll use the useAuth0()
hook within any React component to consume the Auth0Context
associated with the Auth0ProviderWithNavigate
. The useAuth0()
hook will give you access to the Auth0 React SDK loading state, the user authentication status, the user profile information, and helper methods that trigger events related to the authentication process.
Auth0 and React connection set
You have completed setting up an authentication service that your React application can consume. All that is left is for you to continue building up the starter project throughout this guide by implementing React components to trigger and manage the authentication flow.
Feel free to dive deeper into the Auth0 Documentation to learn more about how Auth0 helps you save time implementing and managing identity.
Add User Login to React
The steps on how to build a React login form or login page are complex. You can save development time by using a login page hosted by Auth0 that has a built-in login form that supports different types of user authentication: username and password, social login, and Multi-Factor Authentication (MFA). You just need to create a button that takes users from your React application to the login page.
Start by creating a buttons
directory under the src/components
directory:
mkdir src/components/buttons
Create a login-button.js
file under the src/components/buttons
directory:
touch src/components/buttons/login-button.js
Populate src/components/buttons/login-button.js
like so:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";export const LoginButton = () => {const { loginWithRedirect } = useAuth0();const handleLogin = async () => {await loginWithRedirect({appState: {returnTo: "/profile",},});};return (<button className="button__login" onClick={handleLogin}>Log In</button>);};
The loginWithRedirect()
method from the Auth0Context
performs a redirect to the Auth0 /authorize
endpoint to kickstart the authentication process. You can pass a configuration object to this method to customize the login experience.
By setting up the value of appState.returnTo
to /profile
, you are telling the Auth0 React SDK the following: When my users log in with Auth0 and return to my React application, take them from the default callback URL path, /callback
, to the "Profile" page, /profile
. If you don't specify this appState.returnTo
option, your users will be redirected by default to the /
path after they log in.
This loginWithRedirect()
method supports any of the RedirectLoginOptions
properties to customize the user login experience. In the next section, you'll configure this method to create a button that your users can click on to sign up for your application.
Add User Sign-Up to React
The process on how to build a React sign-up form is much more complex. However, you can use a sign-up form hosted by Auth0 that has a built-in password strength verification.
You can create a button that takes users from your React application to the sign-up page by adding another property to the loginWithRedirect()
configuration object: authorizationParams
. The Auth0 React SDK will use the properties you define within the authorizationParams
object as query parameters of the call to the Auth0 /authorize
endpoint. As such, add the screen_hint
property to that object with a value of signup
to accomplish that goal:
authorizationParams: {screen_hint: "signup",}
To see this in practice, create a signup-button.js
file under the src/components/buttons
directory:
touch src/components/buttons/signup-button.js
Populate src/components/buttons/signup-button.js
like so to define a sign-up button component:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";export const SignupButton = () => {const { loginWithRedirect } = useAuth0();const handleSignUp = async () => {await loginWithRedirect({appState: {returnTo: "/profile",},authorizationParams: {screen_hint: "signup",},});};return (<button className="button__sign-up" onClick={handleSignUp}>Sign Up</button>);};
Using the Auth0 Signup feature requires you to enable the Auth0 New Universal Login Experience in your tenant.
Open the Universal Login section of the Auth0 Dashboard and choose the "New" option under the "Experience" subsection.
Scroll down and click on the "Save Changes" button.
The difference between the login and sign-up user experience will be more evident once you integrate those components with your React application and see them in action. You'll do that in the following sections.
Add User Logout to React
You can log out users from your React application by logging them out of their Auth0 sessions using the logout()
method from the Auth0 React SDK.
Create a logout-button.js
file under the src/components/buttons
directory:
touch src/components/buttons/logout-button.js
Populate src/components/buttons/logout-button.js
like so:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";export const LogoutButton = () => {const { logout } = useAuth0();const handleLogout = () => {logout({logoutParams: {returnTo: window.location.origin,},});};return (<button className="button__logout" onClick={handleLogout}>Log Out</button>);};
When using the logout()
method, the Auth0 React SDK clears the application session and redirects to the Auth0 /v2/logout
endpoint to clear the Auth0 session under the hood.
As with the login method, you can pass an object argument to logout()
to customize the logout behavior of the React application. You can define a logoutParams
property on that configuration object to define parameters for the /v2/logout
call. This process is fairly invisible to the user. See logoutParams
for more details on the parameters available.
Here, you pass the logoutParams.returnTo
option to specify the URL where Auth0 should redirect your users after they log out. Right now, you are working locally, and your Auth0 application's "Allowed Logout URLs" points to http://localhost:4040
.
However, if you were to deploy your React application to production, you need to add the production logout URL to the "Allowed Logout URLs" list and ensure that Auth0 redirects your users to that production URL and not localhost
. Setting logoutParams.returnTo
to window.location.origin
will do just that.
A best practice when working with Auth0 is to have different tenants for your different project environments. For example, it's recommended for developers to specify a production tenant. A production tenant gets higher rate limits than non-production tenants. Check out the "Set Up Multiple Environments" Auth0 document to learn more about how to set up development, staging, and production environments in the Auth0 Identity Platform.
Render React Components Based on Authentication
In this section, you'll learn how to render React components conditionally based on the status of the Auth0 React SDK or the authentication status of your users.
Render the authentication buttons conditionally
The React starter application features a desktop and mobile navigation experience.
When using your React application on a viewport large enough to fix a desktop or tablet experience, you'll see a navigation bar at the top of the page.
When using a viewport that fits the screen constraints of a mobile device, you'll see a menu button at the top-right corner of the page. Tapping or clicking on the menu button opens a modal that shows you the different pages that you can access in the application.
In this section, you'll expose the button components that trigger the login, sign-up, and logout events through these page navigation elements.
Let's start with the desktop navigation user experience. You'll show both the login and sign-up buttons on the navigation bar when the user is not logged in. Naturally, you'll show the logout button when when the user is logged in.
Update src/components/navigation/desktop/nav-bar-buttons.js
as follows to implement the user experience defined above:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { LoginButton } from "../../buttons/login-button";import { LogoutButton } from "../../buttons/logout-button";import { SignupButton } from "../../buttons/signup-button";export const NavBarButtons = () => {const { isAuthenticated } = useAuth0();return (<div className="nav-bar__buttons">{!isAuthenticated && (<><SignupButton /><LoginButton /></>)}{isAuthenticated && (<><LogoutButton /></>)}</div>);};
The isAuthenticated
value reflects the authentication state of your users as tracked by the Auth0 React SDK. This value is true
when the user has been authenticated and false
when not. As such, you can use the isAuthenticated
value to render UI elements conditionally depending on the authentication state of your users, as you did above.
The mobile navigation experience works in the same fashion, except that the authentication-related buttons are tucked into the mobile menu modal.
Update src/components/navigation/mobile/mobile-nav-bar-buttons.js
as follows:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { LoginButton } from "../../buttons/login-button";import { LogoutButton } from "../../buttons/logout-button";import { SignupButton } from "../../buttons/signup-button";export const MobileNavBarButtons = () => {const { isAuthenticated } = useAuth0();return (<div className="mobile-nav-bar__buttons">{!isAuthenticated && (<><SignupButton /><LoginButton /></>)}{isAuthenticated && (<><LogoutButton /></>)}</div>);};
Go ahead and try to log in. Your React application redirects you to the Auth0 Universal Login page. You can use the form to log in with a username and password or a social identity provider like Google. Notice that this login page also gives you the option to sign up.
However, when you click the sign-up button from your application directly, React takes you to the Signup page, where your users can sign up for the React application. Try it out!
Notice that when you finish logging in or signing up, Auth0 redirects you to your React app, but the login and sign-up buttons may briefly show up before the logout button renders. You'll fix that next.
Render the application conditionally
The user interface flashes because your React app doesn't know if Auth0 has authenticated the user yet. Your React application will know the user authentication status after the Auth0 React SDK initializes.
To fix that UI flashing, use the isLoading
value from the useAuth0()
React hook to render the App
component once the Auth0 React SDK has finished loading.
Open src/app.js
and update it as follows:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { Route, Routes } from "react-router-dom";import { PageLoader } from "./components/page-loader";import { AdminPage } from "./pages/admin-page";import { CallbackPage } from "./pages/callback-page";import { HomePage } from "./pages/home-page";import { NotFoundPage } from "./pages/not-found-page";import { ProfilePage } from "./pages/profile-page";import { ProtectedPage } from "./pages/protected-page";import { PublicPage } from "./pages/public-page";export const App = () => {const { isLoading } = useAuth0();if (isLoading) {return (<div className="page-layout"><PageLoader /></div>);}return (<Routes><Route path="/" element={<HomePage />} /><Route path="/profile" element={<ProfilePage />} /><Route path="/public" element={<PublicPage />} /><Route path="/protected" element={<ProtectedPage />} /><Route path="/admin" element={<AdminPage />} /><Route path="/callback" element={<CallbackPage />} /><Route path="*" element={<NotFoundPage />} /></Routes>);};
While the SDK is loading, the PageLoader
component renders, which shows up an animation. Log out and log back in to see this in action. No more UI flashing should happen.
Render navigation tabs conditionally
There may be use cases where you want to hide user interface elements from users who have not logged in to your application. For this starter application, only authenticated users should see the navigation tabs to access the /protected
and /admin
pages.
To implement this use case, you'll rely once again on the isAuthenticated
value from the useAuth0()
hook.
Open the src/components/navigation/desktop/nav-bar-tabs.js
component file that defines your desktop navigation tabs and update it like so:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { NavBarTab } from "./nav-bar-tab";export const NavBarTabs = () => {const { isAuthenticated } = useAuth0();return (<div className="nav-bar__tabs"><NavBarTab path="/profile" label="Profile" /><NavBarTab path="/public" label="Public" />{isAuthenticated && (<><NavBarTab path="/protected" label="Protected" /><NavBarTab path="/admin" label="Admin" /></>)}</div>);};
Next, open the src/components/navigation/mobile/mobile-nav-bar-tabs.js
component file that defines your mobile navigation tabs and update it like so:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { MobileNavBarTab } from "./mobile-nav-bar-tab";export const MobileNavBarTabs = ({ handleClick }) => {const { isAuthenticated } = useAuth0();return (<div className="mobile-nav-bar__tabs"><MobileNavBarTabpath="/profile"label="Profile"handleClick={handleClick}/><MobileNavBarTabpath="/public"label="Public"handleClick={handleClick}/>{isAuthenticated && (<><MobileNavBarTabpath="/protected"label="Protected"handleClick={handleClick}/><MobileNavBarTabpath="/admin"label="Admin"handleClick={handleClick}/></>)}</div>);};
Log out from your React application and notice how now you can only see the tabs for the /profile
and /public
pages in the navigation bar, along with the login and sign-up buttons. Log in and then see the rest of the navigation bar show up.
Keep in mind that this does not restrict access to the /admin
and /protected
pages at all. You'll learn how to use the Auth0 React SDK to protect React routes in the next section.
Add Route Guards to React
You'll create an <AuthenticationGuard>
component that requires users to log in before they can access a React route. A guard is a tool that helps you promote data privacy and protection as well as user interface customization. The <AuthenticationGuard>
is a wrapper component that uses withAuthenticationRequired
to make it reusable for the components that you need to protect. As such, you can pass the <AuthenticationGuard>
organically as an element to the <Route>
component from React Router v6
.
v5
with Auth0 to protect React applications, follow the "React Authentication By Example: Using React Router 5" guide.To start, create a authentication-guard.js
file under the src/components/
directory:
touch src/components/authentication-guard.js
Populate src/components/authentication-guard.js
as follows:
import { withAuthenticationRequired } from "@auth0/auth0-react";import React from "react";import { PageLoader } from "./page-loader";export const AuthenticationGuard = ({ component }) => {const Component = withAuthenticationRequired(component, {onRedirecting: () => (<div className="page-layout"><PageLoader /></div>),});return <Component />;};
The withAuthenticationRequired
Higher-Order Component (HOC) takes the following arguments:
-
The component that you want to protect.
-
A configuration object to customize the authentication flow,
WithAuthenticationRequiredOptions
. This object takes the following optional properties:-
loginOptions
: It behaves exactly like the configuration options you can pass tologinWithRedirect()
to customize the login experience. -
returnTo
: It lets you specify a path for React to redirect a user after the login transaction that the user triggered in this component completes. -
onRedirecting
: It renders a component while your React application redirects the user to the login page.
-
-
In the example above, users who have not logged in see the <PageLoader>
component as soon they hit a guarded route. The onRedirecting
component improves the user experience by avoiding any flashing of mixed UI components (protected and public components).
You can apply the route guard to any React route by updating src/app.js
as follows:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { Route, Routes } from "react-router-dom";import { PageLoader } from "./components/page-loader";import { AuthenticationGuard } from "./components/authentication-guard";import { AdminPage } from "./pages/admin-page";import { CallbackPage } from "./pages/callback-page";import { HomePage } from "./pages/home-page";import { NotFoundPage } from "./pages/not-found-page";import { ProfilePage } from "./pages/profile-page";import { ProtectedPage } from "./pages/protected-page";import { PublicPage } from "./pages/public-page";export const App = () => {const { isLoading } = useAuth0();if (isLoading) {return (<div className="page-layout"><PageLoader /></div>);}return (<Routes><Route path="/" element={<HomePage />} /><Routepath="/profile"element={<AuthenticationGuard component={ProfilePage} />}/><Route path="/public" element={<PublicPage />} /><Routepath="/protected"element={<AuthenticationGuard component={ProtectedPage} />}/><Routepath="/admin"element={<AuthenticationGuard component={AdminPage} />}/><Route path="/callback" element={<CallbackPage />} /><Route path="*" element={<NotFoundPage />} /></Routes>);};
You use the <AuthenticationGuard>
component to guard the /profile
, /protected
, and /admin
routes.
You can now test that these guarded paths require users to log in before accessing them. Log out and try to access the Profile page, Protected page, or the Admin page. If it works, React redirects you to log in with Auth0.
Once you log in, React should take you to the /profile
page as specified by the appState.returnTo
property present in the login button component definition.
A note on React.StrictMode
and React v18
While running this React v18
code sample locally in development mode, you'll notice that in some scenarios React makes the same API call twice. Open your browser's developer tools to analyze the network traffic and calls. Then, visit either the /public
page, the /protected
page, or the /admin
page. You'll see that React calls your "Hello Word" API twice.
React is working as expected. There is nothing wrong going on. React v18
makes React stricter by introducing a new development-only check to React.StrictMode
, which this code sample application uses.
The React v18
changelog explains that "React will automatically unmount and remount every component, whenever a component mounts for the first time, restoring the previous state on the second mount. If this breaks your app, consider removing Strict Mode until you can fix the components to be resilient to remounting with existing state."
However, when you run your React v18
applications in production, React will only make one request.
Client-side guards improve the user experience of your React application, not its security.
In Security StackExchange, Conor Mancone explains that server-side guards are about protecting data while client-side guards are about improving user experience.
The main takeaways from his response are:
- You can't rely on client-side restrictions, such as navigation guards and protected routes, to protect sensitive information.
- Attackers can potentially get around client-side restrictions.
- Your server should not return any data that a user should not access.
The wrong approach is to return all the user data from the server and let the front-end framework decide what to display and what to hide based on the user authentication status.
- Anyone can open the browser's developer tools and inspect the network requests to view all the data.
- The use of navigation guards helps improve user experience, not user security.
- Without guards, a user who has not logged in may wander into a page with restricted information and see an error like "Access Denied".
- With guards that match the server permissions, you can prevent users from seeing errors by preventing them from visiting the restricted page.
Get User Profile Information in React
After a user successfully logs in, Auth0 sends an ID token to your React application. Authentication systems, such as Auth0, use ID Tokens in token-based authentication to cache user profile information and provide it to a client application. The caching of ID tokens can improve the performance and responsiveness of your React application.
You can use the data from the ID token to personalize the user interface of your React application. The Auth0 React SDK decodes the ID token and stores its data in the user
object exposed via the useAuth0()
React hook. Some of the ID token information includes the name, nickname, picture, and email of the logged-in user.
How can you use the ID token to create a profile page for your users?
Update src/pages/profile-page.js
as follows:
import { useAuth0 } from "@auth0/auth0-react";import React from "react";import { CodeSnippet } from "../components/code-snippet";import { PageLayout } from "../components/page-layout";export const ProfilePage = () => {const { user } = useAuth0();if (!user) {return null;}return (<PageLayout><div className="content-layout"><h1 id="page-title" className="content__title">Profile Page</h1><div className="content__body"><p id="page-description"><span>You can use the <strong>ID Token</strong> to get the profileinformation of an authenticated user.</span><span><strong>Only authenticated users can access this page.</strong></span></p><div className="profile-grid"><div className="profile__header"><imgsrc={user.picture}alt="Profile"className="profile__avatar"/><div className="profile__headline"><h2 className="profile__title">{user.name}</h2><span className="profile__description">{user.email}</span></div></div><div className="profile__details"><CodeSnippettitle="Decoded ID Token"code={JSON.stringify(user, null, 2)}/></div></div></div></div></PageLayout>);};
What's happening within the <ProfilePage>
component?
-
You display three properties from the
user
object in the user interface:name
,picture
, andemail
. -
Since the data comes from a simple object, you don't have to fetch it using any asynchronous calls.
-
Finally, you display the full content of the decoded ID token within a code box. You can now see all the other properties available for you to use. The properties are known as "token claims".
The <ProfilePage>
component renders user information that you could consider private or sensitive. Additionally, the user
property is null
if there is no logged-in user. So either way, this component should only render if Auth0 has authenticated the user. You are already restricting access to this page component by using the <AuthenticationGuard>
component to guard the /profile
route definition of your React application, src/app.js
.
If you are logged in to your application, visit http://localhost:4040/profile
to see your user profile details.
Integrate React with an API Server
This section focuses on showing you how to get an access token in your React application and how to use it to make API calls to protected API endpoints.
When you use Auth0, you delegate the authentication process to a centralized service. Auth0 provides you with functionality to log in and log out users from your React application. However, your application may need to access protected resources from an API.
You can also protect an API with Auth0. There are multiple API quickstarts to help you integrate Auth0 with your backend platform.
When you use Auth0 to protect your API, you also delegate the authorization process to a centralized service that ensures only approved client applications can access protected resources on behalf of a user.
How can you make secure API calls from React?
Your React application authenticates the user and receives an access token from Auth0. The application can then pass that access token to your API as a credential. In turn, your API can use Auth0 libraries to verify the access token it receives from the calling application and issue a response with the desired data.
Instead of creating an API from scratch to test the authentication and authorization flow between the client and the server, you can pair this client application with an API server that matches the technology stack you use at work. The React "Hello World" client application that you have been building up can interact with any of the "Hello World" API server samples from the Auth0 Developer Center.
The "Hello World" API server samples run on http://localhost:6060
by default, which is the same origin URL and port where the mocked JSON server is running. As such, before you set up the "Hello World" API server, locate the tab where you are running the npm run api
command and stop the mocked JSON server.
Pick an API code sample in your preferred backend framework and language from the list below and follow the instructions on the code sample page to set it up. Once you complete the sample API server setup, please return to this page to learn how to integrate that API server with your React application.
Call a Protected API from React
Once you have set up the API server code sample, you should have created an Auth0 Audience value. Store that value in the following field so that you can use it throughout the instructions presented on this page easily:
Now, update the .env
file under the React project directory as follows:
REACT_APP_API_SERVER_URL=http://localhost:6060REACT_APP_AUTH0_DOMAIN=AUTH0-DOMAINREACT_APP_AUTH0_CLIENT_ID=AUTH0-CLIENT-IDREACT_APP_AUTH0_CALLBACK_URL=http://localhost:4040/callbackREACT_APP_AUTH0_AUDIENCE=AUTH0-AUDIENCE
You are using REACT_APP_AUTH0_AUDIENCE
to add the value of your Auth0 API Audience so that your React client application can request resources from the API that such audience value represents.
Restart your development server so that your React project can become aware of these .env
file changes:
npm start
Let's understand better what the REACT_APP_AUTH0_AUDIENCE
and REACT_APP_API_SERVER_URL
values represent.
The REACT_APP_API_SERVER_URL
is simply the URL where your sample API server listens for requests. In production, you'll change this value to the URL of your live server.
Your React application must pass an access token when it calls a target API to access protected resources. You can request an access token in a format that the API can verify by passing the audience
to the Auth0 React SDK.
The value of the Auth0 Audience must be the same for both the React client application and the API server you decided to set up.
Why is the Auth0 Audience value the same for both apps? Auth0 uses the audience
value to determine which resource server (API) the user is authorizing your React application to access. It's like a phone number. You want to ensure that your React application "texts the right API".
As such, update the src/auth0-provider-with-navigate.js
file from your React project as follows to add the audience
value:
import { Auth0Provider } from "@auth0/auth0-react";import React from "react";import { useNavigate } from "react-router-dom";export const Auth0ProviderWithNavigate = ({ children }) => {const navigate = useNavigate();const domain = process.env.REACT_APP_AUTH0_DOMAIN;const clientId = process.env.REACT_APP_AUTH0_CLIENT_ID;const redirectUri = process.env.REACT_APP_AUTH0_CALLBACK_URL;const audience = process.env.REACT_APP_AUTH0_AUDIENCE;const onRedirectCallback = (appState) => {navigate(appState?.returnTo || window.location.pathname);};if (!(domain && clientId && redirectUri && audience)) {return null;}return (<Auth0Providerdomain={domain}clientId={clientId}authorizationParams={{audience: audience,redirect_uri: redirectUri,}}onRedirectCallback={onRedirectCallback}>{children}</Auth0Provider>);};
You are now including an audience
property in the authorizationParams
prop in the Auth0Provider
.
What about using scopes?
A property that you are not configuring directly in the <Auth0Provider>
is the scope
property. When you don't pass a scope
option to Auth0 React SDK, which powers Auth0Provider
, the SDK defaults to using the OpenID Connect Scopes: openid profile email
.
-
openid
: This scope informs the Auth0 Authorization Server that the Client is making an OpenID Connect (OIDC) request to verify the user's identity. OpenID Connect is an authentication protocol. -
profile
: This scope value requests access to the user's default profile information, such asname
,nickname
, andpicture
. -
email
: This scope value requests access to theemail
andemail_verified
information.
The details of the OpenID Connect Scopes go into the ID Token. However, you can define custom API scopes to implement access control. You'll identify those custom scopes in the calls that your client applications make to that API. Auth0 includes API scopes in the access token as the scope
claim value.
The Auth0 React SDK provides you with a method to get an access token from Auth0: getAccessTokenSilently()
. If you already have an access token stored in memory, but the token is invalid or expired, this method will get you a new one. Usually, getting new access tokens requires the user to log in again. However, The Auth0 React SDK lets you get one in the background without interrupting the user. As the name implies, it's a method to getTokenSilently()
... 🤫😶
It's now time to update the /protected
and /admin
page components to let users retrieve private data from the API server. Please ensure that your sample API server is running as you complete the following steps.
Start by updating the service methods present in the src/services/message.service.js
file as follows:
import { callExternalApi } from "./external-api.service";const apiServerUrl = process.env.REACT_APP_API_SERVER_URL;export const getPublicResource = async () => {const config = {url: `${apiServerUrl}/api/messages/public`,method: "GET",headers: {"content-type": "application/json",},};const { data, error } = await callExternalApi({ config });return {data: data || null,error,};};export const getProtectedResource = async (accessToken) => {const config = {url: `${apiServerUrl}/api/messages/protected`,method: "GET",headers: {"content-type": "application/json",Authorization: `Bearer ${accessToken}`,},};const { data, error } = await callExternalApi({ config });return {data: data || null,error,};};export const getAdminResource = async (accessToken) => {const config = {url: `${apiServerUrl}/api/messages/admin`,method: "GET",headers: {"content-type": "application/json",Authorization: `Bearer ${accessToken}`,},};const { data, error } = await callExternalApi({ config });return {data: data || null,error,};};
You are changing the signature of the getProtectedResource()
and getAdminResource()
methods to include an accessToken
parameter.
You then pass that accessToken
value as a bearer credential in the authorization header of the request config
object. You make requests from your React application using the callExternalApi()
helper method defined in the src/services/external-api.service.js
module. callExternalApi()
uses axios
to make its API calls.
With the message service methods in place, proceed to update the src/pages/protected-page.js
file as follows:
import { useAuth0 } from "@auth0/auth0-react";import React, { useEffect, useState } from "react";import { CodeSnippet } from "../components/code-snippet";import { PageLayout } from "../components/page-layout";import { getProtectedResource } from "../services/message.service";export const ProtectedPage = () => {const [message, setMessage] = useState("");const { getAccessTokenSilently } = useAuth0();useEffect(() => {let isMounted = true;const getMessage = async () => {const accessToken = await getAccessTokenSilently();const { data, error } = await getProtectedResource(accessToken);if (!isMounted) {return;}if (data) {setMessage(JSON.stringify(data, null, 2));}if (error) {setMessage(JSON.stringify(error, null, 2));}};getMessage();return () => {isMounted = false;};}, [getAccessTokenSilently]);return (<PageLayout><div className="content-layout"><h1 id="page-title" className="content__title">Protected Page</h1><div className="content__body"><p id="page-description"><span>This page retrieves a <strong>protected message</strong> from anexternal API.</span><span><strong>Only authenticated users can access this page.</strong></span></p><CodeSnippet title="Protected Message" code={message} /></div></div></PageLayout>);};
What is happening now within the <ProtectedPage>
component?
-
You call the
getMessage()
method to request data from your API server to hydrate your page. -
Within the body of the
getMessage()
method, you call theasync getAccessTokenSilently()
method to fetch a new access token from the Auth0 Authorization Server. Under the hood, the Auth0 React SDK triggers a call to the Auth0/oauth/token
endpoint.- Your previous login request did not include an audience parameter. As such, the Auth0 React SDK doesn't have an access token stored in memory, and it requests a new one.
- The SDK will now store that access token in memory. For future
getAccessTokenSilently()
calls, the SDK will use the stored access token and only request a new one when the stored access token expires.
-
You then use the
getProtectedResource()
service method to fetch the protected message from your API server.- You pass the access token that you fetched to this service method.
- In turn,
getProtectedResource()
passes that access token as a bearer credential in the authorization header of the request it makes to your API server.
-
Finally, if you retrieve the data from the server correctly, you'll display that message data in the message box. Otherwise, you'll show the corresponding error message.
Log out from your React application and log back in to get a new access token from Auth0 that includes the audience information.
Visit the http://localhost:4040/protected
page and verify that you now get a valid response from the server.
Now, update the src/pages/admin-page.js
file to implement the same business logic outlined before but this time using the getAdminResource()
service method within the getMessage()
method to retrieve the correct message:
import { useAuth0 } from "@auth0/auth0-react";import React, { useEffect, useState } from "react";import { CodeSnippet } from "../components/code-snippet";import { PageLayout } from "../components/page-layout";import { getAdminResource } from "../services/message.service";export const AdminPage = () => {const [message, setMessage] = useState("");const { getAccessTokenSilently } = useAuth0();useEffect(() => {let isMounted = true;const getMessage = async () => {const accessToken = await getAccessTokenSilently();const { data, error } = await getAdminResource(accessToken);if (!isMounted) {return;}if (data) {setMessage(JSON.stringify(data, null, 2));}if (error) {setMessage(JSON.stringify(error, null, 2));}};getMessage();return () => {isMounted = false;};}, [getAccessTokenSilently]);return (<PageLayout><div className="content-layout"><h1 id="page-title" className="content__title">Admin Page</h1><div className="content__body"><p id="page-description"><span>This page retrieves an <strong>admin message</strong> from anexternal API.</span><span><strong>Only authenticated users with the{" "}<code>read:admin-messages</code> permission should access thispage.</strong></span></p><CodeSnippet title="Admin Message" code={message} /></div></div></PageLayout>);};
That's all it takes to integrate React with an external API server that is also secured by Auth0 and to use an access token to consume protected server resources from your React client application.
Next Steps
You have implemented user authentication in React to identify your users, get user profile information, and control the content that your users can access by protecting routes and API resources.
This guide covered the most common authentication use case for a React application: simple login and logout. However, Auth0 is an extensible and flexible identity platform that can help you achieve even more. If you have a more complex use case, check out the Auth0 Architecture Scenarios to learn more about the typical architecture scenarios we have identified when working with customers on implementing Auth0.
We'll cover advanced authentication patterns and tooling in future guides, such as using a pop-up instead of redirecting users to log in, adding permissions to ID tokens, using metadata to enhance user profiles, and much more.

Vue.js Authentication By Example: Composition API
The Vue.js example on this guide use the Composition API to cover:
- How to add user login, sign-up, and logout to Vue.js applications.
- How to create route guards to protect Vue.js application routes.
- How to make API calls from Vue.js to request data from a protected API.
- How to get user profile information to personalize a Vue.js user interface.
This guide uses the Auth0 Vue SDK to handle all the tasks related to Vue.js authentication. You can secure your Vue.js applications following security best practices while writing less code.
Quick Vue.js Setup
With the help of Auth0, you don't need to be an expert on identity protocols, such as OAuth 2.0 or OpenID Connect, to understand how to secure your web application stack.
You start by integrating your Vue.js application with Auth0. Your application will then redirect users to a customizable login page whenever they need to log in. Once your users log in successfully, Auth0 redirects them back to your Vue.js app, returning JSON Web Tokens (JWTs) with their authentication and user information.
Get the Vue.js Starter Application
We have created a starter project using create-vue
to help you learn Vue.js security concepts through hands-on practice. You can focus on building Vue.js components with the Composition API and services to secure your application.
Start by cloning the spa_vue_javascript_hello-world_composition-api
repository on its starter
branch:
git clone -b starter [email protected]:auth0-developer-hub/spa_vue_javascript_hello-world_composition-api.git
Once you clone the repo, make spa_vue_javascript_hello-world_composition-api
your current directory:
cd spa_vue_javascript_hello-world_composition-api
Install the Vue.js project dependencies as follows:
npm install
This starter Vue.js Composition API project offers a functional application that consumes data from an external API to hydrate the user interface. For simplicity and convenience, the starter project simulates the external API locally using json-server
. Later on, you'll integrate this Vue.js Composition API application with a real API server using a backend technology of your choice.
The compatible API server runs on http://localhost:6060
by default. As such, to connect your Vue.js Composition API application with that API server, create a .env
file under the root project directory:
touch .env
Populate it with the following environment variables:
VITE_API_SERVER_URL=http://localhost:6060
The official Vue.js build setup is now based on Vite, a front-end build tool that is lightweight and fast. Vite will only expose environment variables from .env
to your Vite-processed code if those variables are prefixed with VITE_
. This practice helps you prevent accidentally leaking your system's environment variables to your client application.
Next, execute the following command to run the JSON server API:
npm run api
Finally, open another terminal tab and execute this command to run your Vue.js Composition API application:
npm run dev
You are ready to start implementing user authentication in this Vue.js Composition API project. First, you'll need to configure the Vue.js application to connect successfully to Auth0. Afterward, you'll use the Auth0 Vue SDK to protect routes, display user profile information, and request protected data from an external API server to hydrate some of the application pages.
Configure Vue.js Composition API with Auth0
Follow these steps to get started with the Auth0 Identity Platform quickly:
Sign up and create an Auth0 Application
A free account also offers you:
- Auth0 Universal Login for Web, iOS & Android.
- Up to 2 social identity providers like Google, GitHub, and Twitter.
- Up to 3 Actions, Rules, & Hooks to customize and extend Auth0's capabilities.
During the sign-up process, you create something called an Auth0 Tenant, representing the product or service to which you are adding authentication.
Once you sign in, Auth0 takes you to the Dashboard. In the left sidebar menu, click on "Applications".
Then, click the "Create Application" button. A modal opens up with a form to provide a name for the application and choose its type. Use the following values:
Auth0 Vue.js Code Sample
Click the "Create" button to complete the process. Your Auth0 application page loads up.
In the next step, you'll learn how to help Vue.js and Auth0 communicate.
What's the relationship between Auth0 Tenants and Auth0 Applications?
Let's say that you have a photo-sharing Vue.js app called "Vuetigram". You then would create an Auth0 tenant called vuetigram
. From a customer perspective, Vuetigram is that customer's product or service.
Now, say that Vuetigram is available on three platforms: web as a single-page application and Android and iOS as a native mobile application. If each platform needs authentication, you need to create three Auth0 applications to provide the product with everything it needs to authenticate users through that platform.
Vuetigram users belong to the Auth0 Vuetigram tenant, which shares them across its Auth0 applications.
Create a communication bridge between Vue.js and Auth0
When using the Auth0 Identity Platform, you don't have to build login forms. Auth0 offers a Universal Login Page to reduce the overhead of adding and managing authentication.
How does Universal Login work?
Your Vue.js application will redirect users to Auth0 whenever they trigger an authentication request. Auth0 will present them with a login page. Once they log in, Auth0 will redirect them back to your Vue.js application. For that redirecting to happen securely, you must specify in your Auth0 Application Settings the URLs to which Auth0 can redirect users once it authenticates them.
As such, click on the "Settings" tab of your Auth0 Application page, locate the "Application URIs" section, and fill in the following values:
http://localhost:4040/callback
The above value is the URL that Auth0 can use to redirect your users after they successfully log in.
http://localhost:4040
The above value is the URL that Auth0 can use to redirect your users after they log out.
http://localhost:4040
Using the Auth0 Vue SDK, your Vue.js application will make requests under the hood to an Auth0 URL to handle authentication requests. As such, you need to add your Vue.js application origin URL to avoid Cross-Origin Resource Sharing (CORS) issues.
Scroll down and click the "Save Changes" button.
Do not close this page yet. You'll need some of its information in the next section.
Add the Auth0 configuration variables to Vue.js
From the Auth0 Application Settings page, you need the Auth0 Domain and Client ID values to allow your Vue.js application to use the communication bridge you created.
What exactly is an Auth0 Domain and an Auth0 Client ID?
Domain
When you created a new Auth0 account, Auth0 asked you to pick a name for your tenant. This name, appended with auth0.com
, is your Auth0 Domain. It's the base URL that you will use to access the Auth0 APIs and the URL where you'll redirect users to log in.
Client ID
Each application is assigned a Client ID upon creation, which is an alphanumeric string, and it's the unique identifier for your application (such as q8fij2iug0CmgPLfTfG1tZGdTQyGaTUA
). You cannot modify the Client ID. You will use the Client ID to identify the Auth0 Application to which the Auth0 SPA SDK needs to connect.
Warning: Another critical piece of information present in the "Settings" is the Client Secret. This secret protects your resources by only granting tokens to requestors if they're authorized. Think of it as your application's password, which must be kept confidential at all times. If anyone gains access to your Client Secret, they can impersonate your application and access protected resources.
Head back to your Auth0 application page and click on the "Settings" tab.
Locate the "Basic Information" section and follow these steps to get the Auth0 Domain and Auth0 Client ID values:
When you enter a value in the input fields present on this page, any code snippet that uses such value updates to reflect it. Using the input fields makes it easy to copy and paste code as you follow along.
As such, enter the "Domain" and "Client ID" values in the following fields to set up your single-page application in the next section:
These variables let your Vue.js application identify itself as an authorized party to interact with the Auth0 authentication server.
Now, update the .env
file under the Vue.js project directory as follows:
VITE_API_SERVER_URL=http://localhost:6060VITE_AUTH0_DOMAIN=AUTH0-DOMAINVITE_AUTH0_CLIENT_ID=AUTH0-CLIENT-IDVITE_AUTH0_CALLBACK_URL=http://localhost:4040/callback
Once you reach the "Call a Protected API from Vue.js" section of this guide, you'll learn how to use VITE_API_SERVER_URL
along with an Auth0 Audience value to request protected resources from an external API that is also protected by Auth0. For now, the application is using json-server
to mock the API.
Handle the Auth0 post-login behavior
Notice that the Auth0 Callback URL, VITE_AUTH0_CALLBACK_URL
, points to http://localhost:4040/callback
, which is the URL that Auth0 uses to redirect your users after they successfully log in. For this Vue.js Composition API application, you'll render a simple page component for the /callback
route.
Create a callback-page.vue
file under the src/pages
directory:
touch src/pages/callback-page.vue
Populate src/pages/callback-page.vue
with the following code:
<template><div class="page-layout"><NavBar /><MobileNavBar /><div class="page-layout__content"><slot /></div></div></template><script setup>import NavBar from "@/components/navigation/desktop/nav-bar.vue";import MobileNavBar from "@/components/navigation/mobile/mobile-nav-bar.vue";</script>
The callback-page.vue
component will only render the navigation bar and an empty content container to help you create a smooth transition between a route with no content, /callback
, to a route with content, such as the /profile
page.
The next step is to integrate your callback-page.vue
component with the Vue.js router.
Locate the src/router/index.js
file, which defines your Vue.js router module, and update it like so:
import HomePage from "@/pages/home-page.vue";import { createRouter, createWebHistory } from "vue-router";const NotFoundPage = () => import("@/pages/not-found-page.vue");const ProfilePage = () => import("@/pages/profile-page.vue");const PublicPage = () => import("@/pages/public-page.vue");const ProtectedPage = () => import("@/pages/protected-page.vue");const AdminPage = () => import("@/pages/admin-page.vue");const CallbackPage = () => import("@/pages/callback-page.vue");const routes = [{path: "/",name: "home",component: HomePage,},{path: "/profile",name: "profile",component: ProfilePage,},{path: "/public",name: "public",component: PublicPage,},{path: "/protected",name: "protected",component: ProtectedPage,},{path: "/admin",name: "admin",component: AdminPage,},{path: "/callback",name: "callback",component: CallbackPage,},{path: "/:catchAll(.*)",name: "Not Found",component: NotFoundPage,},];const router = createRouter({history: createWebHistory(import.meta.env.BASE_URL),routes,});export default router;
What are the benefits of using a callback page?
Implementing a page that specializes in handling the user redirection from the Auth0 Universal Login Page to your application (the callback event) has some benefits:
- Your users won't see any flashing of the home page component, which renders at the root path,
/
. - By showing the navigation bar in the
/callback
route, your user may feel that your Vue.js application loads fast. - By not showing the footer, your users may feel that your Vue.js application loads smoothly.
- If you were to render the footer component, your application may appear to be jumpy as the footer may show up briefly but then it would be pushed down when the content above it loads.
- You can avoid making unnecessary or costly API calls that may run when loading your home page components.
Once you add a login and logout button to this app, you can verify this user experience improvement by using your browser's developer tools. In the case of Google Chrome, you could do the following:
- Configure Chrome to emulate slow network connections to observe how the application loads after logging in.
- Record the runtime performance of your Vue.js application. Once done, observe the rendering order of pages and elements in the timeline Chrome produces.
If you are not convinced yet, let's explore more details on the impact of this strategy.
Imagine that you want to redirect your users to the /profile
after they log in. If you were to use the root URL of your Vue.js Composition API application, http://localhost:4040
, as the Auth0 Callback URL, you may hurt the user experience when the user's connection is slow or when you are lazy loading the /profile
route:
- This Vue.js application offers a
/profile
page that will display user profile information such as name and email address. However, this application also lazy loads that/profile
route using the Vue.js Router. - Since user profile information is private, it must be protected against unauthorized access.
- The Auth0 Vue SDK allows you to easily require users to log in before they can access a route.
- When a user who is not logged in clicks on the
/profile
page navigation tab, Auth0 will redirect them to a page to log in. - Once your users log in, Auth0 will redirect them to your Vue.js application with some metadata that allows your application to redirect them to the protected page they intended to access.
- When you use
http://localhost:4040
as the Auth0 Callback URL, Auth0 will redirect your users to the home page first. Depending on how fast your application renders pages and handles redirects, your users may see the home page first before Vue.js takes them to the/profile
page when the connection is slow or when you are lazy loading that route. This quick re-routing makes your user interface "flash", which makes the user interface feel janky or glitchy. - However, when you use
http://localhost:4040/callback
as the Auth0 Callback URL, Auth0 will take your users to a/callback
route after they log in. You can then display a loading animation or nothing at all in that special route. Doing so makes the transition from/callback
to/profile
smoother as no unrelated or unexpected content shows up in the process.
Additionally, when you load the home page, /
, you may trigger logic that fetches data from an external API or runs any other business logic related to hydrating the home page. If your intention is to show the users a /profile
page after they log in, there's no need or value to run any of that home page business logic that won't impact the rendering of the /profile
page. Instead, you may increase your operational costs by running unnecessary logic when any of your users log in. In that case, it's better to handle the Auth0 redirect in a minimal and performant specialized route, /callback
.
Configure a Vue.js Authentication Plugin
It's important to note that the Auth0 Vue SDK is only compatible with Vue 3. It won't work with Vue.js v2
and below. Execute the following command to install the Auth0 Vue SDK:
npm install @auth0/auth0-vue
The Auth0 Vue SDK exposes the createAuth0()
method that you can use to instantiate an Auth0 Vue.js plugin. You can connect that Auth0 plugin with your Vue.js application by passing the plugin instance to the app.use()
method from Vue.js.
Update the src/main.js
file as follows to execute the steps above:
import { createAuth0 } from "@auth0/auth0-vue";import { createApp } from "vue";import App from "./app.vue";import "./assets/css/styles.css";import router from "./router";const app = createApp(App);app.use(router).use(createAuth0({domain: import.meta.env.VITE_AUTH0_DOMAIN,clientId: import.meta.env.VITE_AUTH0_CLIENT_ID,authorizationParams: {redirect_uri: import.meta.env.VITE_AUTH0_CALLBACK_URL,},})).mount("#root");
You define an instance of the authentication plugin from the Auth0 Vue SDK using the configuration values from the Auth0 application you created in the Auth0 Dashboard: Auth0 Domain and Client ID.
Additionally, you use the authorizationParams
configuration object to define the query parameters that Vue needs to include on its calls to the Auth0 /authorize
endpoint. You define the redirect_uri
property within this object to specify the URL from your Vue.js application to where Auth0 should redirect your users after they successfully log in.
Router
and Auth0 Vue.js plugin
with your Vue.js instance is important. You must register the Vue.js Router
before the Auth0 Vue.js plugin
, or you might experience unexpected behavior. 🚨.When you use the Vue.js Composition API, you'll create Vue.js components using imported functions instead of declaring an options object.
As you'll see throughout this guide, the Composition API is primarily used with the <script setup>
syntax to define Single-File Components (SFCs). You'll notice that the Composition API syntax is much more compact and simpler than the Options API syntax.
To access the functionality of the Auth0 plugin in Vue.js Composition API, you'll call the useAuth0()
method within your Vue.js components.
The Auth0 Vue SDK is a reactive wrapper around the Auth0 SPA SDK, making it easier to work with the asynchronous methods of the SDK in the context of a Vue.js application.
As such, all the configuration options for helper methods of the Auth0 SPA SDK also work with the helper methods of the Auth0 Vue SDK. You'll see examples of this compatibility when you create the Vue.js sign-up and logout buttons using the Composition API in the following sections.
Auth0 and Vue.js connection set
You have completed setting up an authentication service that your Vue.js application can consume. All that is left is for you to continue building up the starter project throughout this guide by implementing components with the Vue.js Composition API to trigger and manage the authentication flow.
Feel free to dive deeper into the Auth0 Documentation to learn more about how Auth0 helps you save time implementing and managing identity.
Add User Login to Vue.js
The steps on how to build a Vue.js login form or login page are complex. You can save development time by using a login page hosted by Auth0 that has a built-in login form that supports different types of user authentication: username and password, social login, and Multi-Factor Authentication (MFA). You just need to create a button that takes users from your Vue.js application to the login page.
Start by creating a buttons
directory under the src/components
directory:
mkdir src/components/buttons
Create a login-button.vue
file under the src/components/buttons
directory:
touch src/components/buttons/login-button.vue
kebab-case
and not PascalCase
to create Vue.js component files, *.vue
? According to the Vue.js Style Guide, "PascalCase works best with autocompletion in code editors, as it's consistent with how we reference components in JS(X) and templates, wherever possible. However, mixed case filenames can sometimes create issues on case-insensitive file systems, which is why kebab-case is also perfectly acceptable".Populate src/components/buttons/login-button.vue
like so:
<template><button class="button__login" @click="handleLogin">Log In</button></template><script setup>import { useAuth0 } from "@auth0/auth0-vue";const { loginWithRedirect } = useAuth0();const handleLogin = () => {loginWithRedirect({appState: {target: "/profile",},});};</script>
As mentioned earlier, when you use the Vue.js Composition API, you access the Auth0 plugin within your Vue.js components using the useAuth0()
method. This pattern looks very similar to the Hooks pattern from the Vue.js framework.
The loginWithRedirect()
method performs a redirect to the Auth0 /authorize
endpoint to kickstart the authentication process. You can pass a configuration object to this method to customize the login experience.
By setting up the value of appState.target
to /profile
, you are telling the Auth0 Vue SDK the following: When my users log in with Auth0 and return to my Vue.js application, take them from the default callback URL path, /callback
, to the "Profile" page, /profile
. If you don't specify this appState.target
option, your users will be redirected by default to the /
path after they log in.
Add User Sign-Up to Vue.js
The process on how to build a Vue.js sign-up form is much more complex. However, you can use a sign-up form hosted by Auth0 that has a built-in password strength verification.
You can create a button that takes users from your Vue.js application to the sign-up page by specifying the screen_hint=signup
property in the authorizationParams
configuration object of the loginWithRedirect()
method:
authorizationParams: {screen_hint: "signup",}
This loginWithRedirect()
method is a wrapper from the Auth0 SPA SDK method of the same name. As such, you can use the RedirectLoginOptions
document from the Auth0 SPA SDK to learn more details on these configuration options.
To see this in practice, create a signup-button.vue
file under the src/components/buttons
directory:
touch src/components/buttons/signup-button.vue
Populate src/components/buttons/signup-button.vue
like so to define a sign-up button component:
<template><button class="button__sign-up" @click="handleSignUp">Sign Up</button></template><script setup>import { useAuth0 } from "@auth0/auth0-vue";const { loginWithRedirect } = useAuth0();const handleSignUp = () => {loginWithRedirect({appState: {target: "/profile",},authorizationParams: {screen_hint: "signup",}});};</script>
Using the Auth0 Signup feature requires you to enable the Auth0 New Universal Login Experience in your tenant.
Open the Universal Login section of the Auth0 Dashboard and choose the "New" option under the "Experience" subsection.
Scroll down and click on the "Save Changes" button.
The difference between the login and sign-up user experience will be more evident once you integrate those components with your Vue.js application and see them in action. You'll do that in the following sections.
Add User Logout to Vue.js
You can log out users from your Vue.js application by logging them out of their Auth0 sessions using the logout()
method from the Auth0 Vue SDK.
Create a logout-button.vue
file under the src/components/buttons
directory:
touch src/components/buttons/logout-button.vue
Populate src/components/buttons/logout-button.vue
like so:
<template><button class="button__logout" @click="handleLogout">Log Out</button></template><script setup>import { useAuth0 } from "@auth0/auth0-vue";const { logout } = useAuth0();const handleLogout = () =>logout({logoutParams: {returnTo: window.location.origin,}});</script>
When using the logout()
method, the Auth0 Vue SDK clears the application session and redirects to the Auth0 /v2/logout
endpoint to clear the Auth0 session under the hood.
As with the login method, you can pass an object argument to logout()
to customize the logout behavior of the Vue.js application. You can define a logoutParams
property on that configuration object to define parameters for the /v2/logout
call. This process is fairly invisible to the user. See logoutParams
for more details on the parameters available.
Here, you pass the logoutParams.returnTo
option to specify the URL where Auth0 should redirect your users after they log out. Right now, you are working locally, and your Auth0 application's "Allowed Logout URLs" points to http://localhost:4040
.
However, if you were to deploy your Vue.js application to production, you need to add the production logout URL to the "Allowed Logout URLs" list and ensure that Auth0 redirects your users to that production URL and not localhost
. Setting logoutParams.returnTo
to window.location.origin
will do just that.
A best practice when working with Auth0 is to have different tenants for your different project environments. For example, it's recommended for developers to specify a production tenant. A production tenant gets higher rate limits than non-production tenants. Check out the "Set Up Multiple Environments" Auth0 document to learn more about how to set up development, staging, and production environments in the Auth0 Identity Platform.
Render Vue.js Components Based on Authentication
In this section, you'll learn how to render Vue.js components conditionally based on the status of the Auth0 Vue SDK or the authentication status of your users.
Render the authentication buttons conditionally
The Vue.js starter application features a desktop and mobile navigation experience.
When using your Vue.js application on a viewport large enough to fix a desktop or tablet experience, you'll see a navigation bar at the top of the page.
When using a viewport that fits the screen constraints of a mobile device, you'll see a menu button at the top-right corner of the page. Tapping or clicking on the menu button opens a modal that shows you the different pages that you can access in the application.
In this section, you'll expose the button components that trigger the login, sign-up, and logout events through these page navigation elements.
Let's start with the desktop navigation user experience. You'll show both the login and sign-up buttons on the navigation bar when the user is not logged in. Naturally, you'll show the logout button when when the user is logged in.
Update src/components/navigation/desktop/nav-bar-buttons.vue
as follows to implement the user experience defined above:
<template><div class="nav-bar__buttons"><template v-if="!isAuthenticated"><SignupButton /><LoginButton /></template><template v-if="isAuthenticated"><LogoutButton /></template></div></template><script setup>import LoginButton from "@/components/buttons/login-button.vue";import LogoutButton from "@/components/buttons/logout-button.vue";import SignupButton from "@/components/buttons/signup-button.vue";import { useAuth0 } from "@auth0/auth0-vue";const { isAuthenticated } = useAuth0();</script>
The isAuthenticated
value reflects the authentication state of your users as tracked by the Auth0 Vue SDK plugin. This value is true
when the user has been authenticated and false
when not. As such, you can use the isAuthenticated
value to render UI elements conditionally depending on the authentication state of your users, as you did above.
The mobile navigation experience works in the same fashion, except that the authentication-related buttons are tucked into the mobile menu modal.
Update src/components/navigation/mobile/mobile-nav-bar-buttons.vue
as follows:
<template><div class="mobile-nav-bar__buttons"><template v-if="!isAuthenticated"><SignupButton /><LoginButton /></template><template v-if="isAuthenticated"><LogoutButton /></template></div></template><script setup>import LoginButton from "@/components/buttons/login-button.vue";import LogoutButton from "@/components/buttons/logout-button.vue";import SignupButton from "@/components/buttons/signup-button.vue";import { useAuth0 } from "@auth0/auth0-vue";const { isAuthenticated } = useAuth0();</script>
Go ahead and try to log in. Your Vue.js application redirects you to the Auth0 Universal Login page. You can use the form to log in with a username and password or a social identity provider like Google. Notice that this login page also gives you the option to sign up.
However, when you click the sign-up button from your application directly, Vue.js takes you to the Signup page, where your users can sign up for the Vue.js application. Try it out!
Notice that when you finish logging in or signing up, Auth0 redirects you to your Vue.js app, but the login and sign-up buttons may briefly show up before the logout button renders. You'll fix that next.
Render the application conditionally
The user interface flashes because your Vue.js app doesn't know if Auth0 has authenticated the user yet. Your Vue.js application will know the user authentication status after the Auth0 Vue SDK initializes.
To fix that UI flashing, use the isLoading
value to render the app.vue
component once the Auth0 Vue SDK has finished loading.
Open src/app.vue
and update it as follows:
<template><div v-if="isLoading" class="page-layout"><PageLoader /></div><router-view v-else /></template><script setup>import PageLoader from "@/components/page-loader.vue";import { useAuth0 } from "@auth0/auth0-vue";const { isLoading } = useAuth0();</script>
While the SDK is loading, the page-loader.vue
component renders, which shows up an animation. Log out and log back in to see this in action. No more UI flashing should happen.
Render navigation tabs conditionally
There may be use cases where you want to hide user interface elements from users who have not logged in to your application. For this starter application, only authenticated users should see the navigation tabs to access the /protected
and /admin
pages.
To implement this use case, you'll rely once again on the isAuthenticated
value from useAuth0()
.
Open the src/components/navigation/desktop/nav-bar-tabs.vue
component file that defines your desktop navigation tabs and update it like so:
<template><div class="nav-bar__tabs"><NavBarTab path="/profile" label="Profile" /><NavBarTab path="/public" label="Public" /><template v-if="isAuthenticated"><NavBarTab path="/protected" label="Protected" /><NavBarTab path="/admin" label="Admin" /></template></div></template><script setup>import NavBarTab from "@/components/navigation/desktop/nav-bar-tab.vue";import { useAuth0 } from "@auth0/auth0-vue";const { isAuthenticated } = useAuth0();</script>
Next, open the src/components/navigation/mobile/mobile-nav-bar-tabs.vue
component file that defines your mobile navigation tabs and update it like so:
<template><div class="mobile-nav-bar__tabs"><MobileNavBarTab path="/profile" label="Profile" /><MobileNavBarTab path="/public" label="Public" /><template v-if="isAuthenticated"><MobileNavBarTab path="/protected" label="Protected" /><MobileNavBarTab path="/admin" label="Admin" /></template></div></template><script setup>import MobileNavBarTab from "@/components/navigation/mobile/mobile-nav-bar-tab.vue";import { useAuth0 } from "@auth0/auth0-vue";const { isAuthenticated } = useAuth0();</script><style scoped></style>
Log out from your Vue.js application and notice how now you can only see the tabs for the /profile
and /public
pages in the navigation bar, along with the login and sign-up buttons. Log in and then see the rest of the navigation bar show up.
Keep in mind that this does not restrict access to the /admin
and /protected
pages at all. You'll learn how to use the Auth0 Vue SDK to protect Vue.js routes in the next section.
Add Route Guards to Vue.js
You can create an authentication route guard to protect Vue.js routes. Vue.js will ask users who visit the route to log in if they haven't already. Once they log in, Vue.js takes them to the route they tried to access.
You can apply a guard to any route defined in the Vue.js router module by updating src/router/index.js
as follows:
import HomePage from "@/pages/home-page.vue";import { authGuard } from "@auth0/auth0-vue";import { createRouter, createWebHistory } from "vue-router";const NotFoundPage = () => import("@/pages/not-found-page.vue");const ProfilePage = () => import("@/pages/profile-page.vue");const PublicPage = () => import("@/pages/public-page.vue");const ProtectedPage = () => import("@/pages/protected-page.vue");const AdminPage = () => import("@/pages/admin-page.vue");const CallbackPage = () => import("@/pages/callback-page.vue");const routes = [{path: "/",name: "home",component: HomePage,},{path: "/profile",name: "profile",component: ProfilePage,beforeEnter: authGuard,},{path: "/public",name: "public",component: PublicPage,},{path: "/protected",name: "protected",component: ProtectedPage,beforeEnter: authGuard,},{path: "/admin",name: "admin",component: AdminPage,beforeEnter: authGuard,},{path: "/callback",name: "callback",component: CallbackPage,},{path: "/:catchAll(.*)",name: "Not Found",component: NotFoundPage,},];const router = createRouter({history: createWebHistory(import.meta.env.BASE_URL),routes,});export default router;
You use the authGuard
from the Auth0 Vue SDK to protect the /profile
, /protected
, and /admin
routes by adding it as the value of the beforeEnter
route configuration property. Since beforeEnter
is a pre-route guard, Vue.js will run authGuard
before accessing that route and rendering any of its components.
If the conditions defined by authGuard
pass, the component renders. Otherwise, authGuard
instructs Vue.js to take you to the Auth0 Universal Login Page to authenticate.
You can now test that these guarded paths require users to log in before accessing them. Log out and try to access the Profile page, Protected page, or the Admin page. If it works, Vue.js redirects you to log in with Auth0.
Once you log in, Vue.js should take you to the /profile
page as specified by the appState.target
property present in the login button component definition.
Client-side guards improve the user experience of your Vue.js application, not its security.
In Security StackExchange, Conor Mancone explains that server-side guards are about protecting data while client-side guards are about improving user experience.
The main takeaways from his response are:
- You can't rely on client-side restrictions, such as navigation guards and protected routes, to protect sensitive information.
- Attackers can potentially get around client-side restrictions.
- Your server should not return any data that a user should not access.
The wrong approach is to return all the user data from the server and let the front-end framework decide what to display and what to hide based on the user authentication status.
- Anyone can open the browser's developer tools and inspect the network requests to view all the data.
- The use of navigation guards helps improve user experience, not user security.
- Without guards, a user who has not logged in may wander into a page with restricted information and see an error like "Access Denied".
- With guards that match the server permissions, you can prevent users from seeing errors by preventing them from visiting the restricted page.
Get User Profile Information in Vue.js
After a user successfully logs in, Auth0 sends an ID token to your Vue.js application. Authentication systems, such as Auth0, use ID Tokens in token-based authentication to cache user profile information and provide it to a client application. The caching of ID tokens can improve performance and responsiveness for your Vue.js application.
You can use the data from the ID token to personalize the user interface of your Vue.js application. The Auth0 Vue SDK decodes the ID token and stores its data in the user
object exposed via the useAuth0()
method. Some of the ID token information includes the name, nickname, picture, and email of the logged-in user.
How can you use the ID token to create a profile page for your users?
Update src/pages/profile-page.vue
as follows:
<template><PageLayout><div class="content-layout"><h1 id="page-title" class="content__title">Profile Page</h1><div class="content__body"><p id="page-description"><span>You can use the <strong>ID Token</strong> to get the profileinformation of an authenticated user.</span><span><strong>Only authenticated users can access this page.</strong></span></p><div class="profile-grid"><div class="profile__header"><img :src="user.picture" alt="Profile" class="profile__avatar" /><div class="profile__headline"><h2 class="profile__title">{{ user.name }}</h2><span class="profile__description">{{ user.email }}</span></div></div><div class="profile__details"><CodeSnippet title="Decoded ID Token" :code="code" /></div></div></div></div></PageLayout></template><script setup>import CodeSnippet from "@/components/code-snippet.vue";import PageLayout from "@/components/page-layout.vue";import { useAuth0 } from "@auth0/auth0-vue";const { user } = useAuth0();const code = user ? JSON.stringify(user.value, null, 2) : "";</script>
What's happening within the profile-page.vue
component?
-
You display three properties from the
user
object in the user interface:name
,picture
, andemail
. -
Since the data comes from a simple object, you don't have to fetch it using any asynchronous calls.
-
Finally, you display the full content of the decoded ID token within a code box. You can now see all the other properties available for you to use. The properties are known as "token claims".
The profile-page.vue
component renders user information that you could consider private or sensitive. Additionally, the user
property is null
if there is no logged-in user. So either way, this component should only render if Auth0 has authenticated the user. You are already restricting access to this page component by using the authGuard
in the /profile
route definition of your Vue.js router module, src/router/index.js
.
If you are logged in to your application, visit http://localhost:4040/profile
to see your user profile details.
Integrate Vue.js with an API Server
This section focuses on showing you how to get an access token in your Vue.js application and how to use it to make API calls to protected API endpoints.
When you use Auth0, you delegate the authentication process to a centralized service. Auth0 provides you with functionality to log in and log out users from your Vue.js application. However, your application may need to access protected resources from an API.
You can also protect an API with Auth0. There are multiple API quickstarts to help you integrate Auth0 with your backend platform.
When you use Auth0 to protect your API, you also delegate the authorization process to a centralized service that ensures only approved client applications can access protected resources on behalf of a user.
How can you make secure API calls from Vue.js?
Your Vue.js application authenticates the user and receives an access token from Auth0. The application can then pass that access token to your API as a credential. In turn, your API can use Auth0 libraries to verify the access token it receives from the calling application and issue a response with the desired data.
Instead of creating an API from scratch to test the authentication and authorization flow between the client and the server, you can pair this client application with an API server that matches the technology stack you use at work. The Vue.js "Hello World" client application that you have been building up can interact with any of the "Hello World" API server samples from the Auth0 Developer Center.
The "Hello World" API server samples run on http://localhost:6060
by default, which is the same origin URL and port where the mocked JSON server is running. As such, before you set up the "Hello World" API server, locate the tab where you are running the npm run api
command and stop the mocked JSON server.
Pick an API code sample in your preferred backend framework and language from the list below and follow the instructions on the code sample page to set it up. Once you complete the sample API server setup, please return to this page to learn how to integrate that API server with your Vue.js application.
Call a Protected API from Vue.js
Once you have set up the API server code sample, you should have created an Auth0 Audience value. Store that value in the following field so that you can use it throughout the instructions presented on this page easily:
Now, update the .env
file under the Vue project directory as follows:
VITE_API_SERVER_URL=http://localhost:6060VITE_AUTH0_DOMAIN=AUTH0-DOMAINVITE_AUTH0_CLIENT_ID=AUTH0-CLIENT-IDVITE_AUTH0_CALLBACK_URL=http://localhost:4040/callbackVITE_AUTH0_AUDIENCE=AUTH0-AUDIENCE
You are using VITE_AUTH0_AUDIENCE
to add the value of your Auth0 API Audience so that your Vue.js client application can request resources from the API that such audience value represents.
Let's understand better what the VITE_AUTH0_AUDIENCE
and VITE_API_SERVER_URL
values represent.
The VITE_API_SERVER_URL
is simply the URL where your sample API server listens for requests. In production, you'll change this value to the URL of your live server.
Your Vue.js application must pass an access token when it calls a target API to access protected resources. You can request an access token in a format that the API can verify by passing the audience
to the Auth0 Vue SDK.
The value of the Auth0 Audience must be the same for both the Vue.js client application and the API server you decided to set up.
Why is the Auth0 Audience value the same for both apps? Auth0 uses the value of the audience
prop to determine which resource server (API) the user is authorizing your Vue.js application to access. It's like a phone number. You want to ensure that your Vue.js application "texts the right API".
As such, update the src/main.js
file from your Vue.js project as follows to add the audience
value:
import { createAuth0 } from "@auth0/auth0-vue";import { createApp } from "vue";import App from "./app.vue";import "./assets/css/styles.css";import router from "./router";const app = createApp(App);app.use(router).use(createAuth0({domain: import.meta.env.VITE_AUTH0_DOMAIN,clientId: import.meta.env.VITE_AUTH0_CLIENT_ID,authorizationParams: {audience: import.meta.env.VITE_AUTH0_AUDIENCE,redirect_uri: import.meta.env.VITE_AUTH0_CALLBACK_URL,},})).mount("#root");
You are now including an audience
property in the authorizationParams
configuration object you pass to the createAuth0()
method. Recall that the createAuth0()
method creates an instance of the Auth0 plugin, which allows you to access the Auth0 Vue SDK methods in your Vue.js components through the useAuth0()
method when using the Composition API.
What about using scopes?
A property that you are not configuring directly in the createAuth0()
method is the scope
property. When you don't pass a scope
option to Auth0 Vue SDK, which powers Auth0Plugin
, the SDK defaults to using the OpenID Connect Scopes: openid profile email
.
-
openid
: This scope informs the Auth0 Authorization Server that the Client is making an OpenID Connect (OIDC) request to verify the user's identity. OpenID Connect is an authentication protocol. -
profile
: This scope value requests access to the user's default profile information, such asname
,nickname
, andpicture
. -
email
: This scope value requests access to theemail
andemail_verified
information.
The details of the OpenID Connect Scopes go into the ID Token. However, you can define custom API scopes to implement access control. You'll identify those custom scopes in the calls that your client applications make to that API. Auth0 includes API scopes in the access token as the scope
claim value.
The Auth0 Vue SDK provides you with a method to get an access token from Auth0: getAccessTokenSilently()
. If you already have an access token stored in memory, but the token is invalid or expired, this method will get you a new one. Usually, getting new access tokens requires the user to log in again. However, The Auth0 Vue SDK lets you get one in the background without interrupting the user. As the name implies, it's a method to getTokenSilently()
... 🤫😶
It's now time to update the /protected
and /admin
pages to let users retrieve private data from the API server. Please ensure that your sample API server is running as you complete the following steps.
Start by updating the service methods present in the src/services/message.service.js
file as follows:
import { callExternalApi } from "./external-api.service";const apiServerUrl = import.meta.env.VITE_API_SERVER_URL;export const getPublicResource = async () => {const config = {url: `${apiServerUrl}/api/messages/public`,method: "GET",headers: {"content-type": "application/json",},};const { data, error } = await callExternalApi({ config });return {data: data || null,error,};};export const getProtectedResource = async (accessToken) => {const config = {url: `${apiServerUrl}/api/messages/protected`,method: "GET",headers: {"content-type": "application/json",Authorization: `Bearer ${accessToken}`,},};const { data, error } = await callExternalApi({ config });return {data: data || null,error,};};export const getAdminResource = async (accessToken) => {const config = {url: `${apiServerUrl}/api/messages/admin`,method: "GET",headers: {"content-type": "application/json",Authorization: `Bearer ${accessToken}`,},};const { data, error } = await callExternalApi({ config });return {data: data || null,error,};};
You are changing the signature of the getProtectedResource()
and getAdminResource()
methods to include an accessToken
parameter.
You then pass that accessToken
value as a bearer credential in the authorization header of the request config
object. You make requests from your Vue.js application using the callExternalApi()
helper method defined in the src/services/external-api.service.js
module. callExternalApi()
uses axios
to make its API calls.
With the message service methods in place, proceed to update the src/pages/protected-page.vue
component as follows:
<template><PageLayout><div class="content-layout"><h1 id="page-title" class="content__title">Protected Page</h1><div class="content__body"><p id="page-description"><span>This page retrieves a <strong>protected message</strong> from anexternal API.</span><span><strong>Only authenticated users can access this page.</strong></span></p><CodeSnippet title="Protected Message" :code="message" /></div></div></PageLayout></template><script setup>import CodeSnippet from "@/components/code-snippet.vue";import PageLayout from "@/components/page-layout.vue";import { getProtectedResource } from "@/services/message.service";import { ref } from "vue";import { useAuth0 } from "@auth0/auth0-vue";const message = ref("");const getMessage = async () => {const { getAccessTokenSilently } = useAuth0();const accessToken = await getAccessTokenSilently();const { data, error } = await getProtectedResource(accessToken);if (data) {message.value = JSON.stringify(data, null, 2);}if (error) {message.value = JSON.stringify(error, null, 2);}};getMessage();</script>
What is happening now within the protected-page.vue
component?
-
You call the
getMessage()
method to request data from your API server to hydrate your page. -
Within the body of the
getMessage()
method, you call theasync getAccessTokenSilently()
method to fetch a new access token from the Auth0 Authorization Server. Under the hood, the Auth0 Vue SDK triggers a call to the Auth0/oauth/token
endpoint.- Your previous login request did not include an audience parameter. As such, the Auth0 Vue SDK doesn't have an access token stored in memory, and it requests a new one.
- The SDK will now store that access token in memory. For future
getAccessTokenSilently()
calls, the SDK will use the stored access token and only request a new one when the stored access token expires.
-
You then use the
getProtectedResource()
service method to fetch the protected message from your API server.- You pass the access token that you fetched to this service method.
- In turn,
getProtectedResource()
passes that access token as a bearer credential in the authorization header of the request it makes to your API server.
-
Finally, if you retrieve the data from the server correctly, you'll display that message data in the message box. Otherwise, you'll show the corresponding error message.
Log out from your Vue.js application and log back in to get a new access token from Auth0 that includes the audience information.
Visit the http://localhost:4040/protected
page and verify that you now get a valid response from the server.
Now, update the src/pages/admin-page.vue
component to implement the same business logic outlined before but this time using the getAdminResource()
service method within the getMessage()
method to retrieve the correct message:
<template><PageLayout><div class="content-layout"><h1 id="page-title" class="content__title">Admin Page</h1><div class="content__body"><p id="page-description"><span>This page retrieves an <strong>admin message</strong> from anexternal API.</span><span><strong>Only authenticated users with the<code>read:admin-messages</code> permission should access thispage.</strong></span></p><CodeSnippet title="Admin Message" :code="message" /></div></div></PageLayout></template><script setup>import CodeSnippet from "@/components/code-snippet.vue";import PageLayout from "@/components/page-layout.vue";import { getAdminResource } from "@/services/message.service";import { ref } from "vue";import { useAuth0 } from "@auth0/auth0-vue";const message = ref("");const getMessage = async () => {const { getAccessTokenSilently } = useAuth0();const accessToken = await getAccessTokenSilently();const { data, error } = await getAdminResource(accessToken);if (data) {message.value = JSON.stringify(data, null, 2);}if (error) {message.value = JSON.stringify(error, null, 2);}};getMessage();</script>
That's all it takes to integrate Vue.js with an external API server that is also secured by Auth0 and to use an access token to consume protected server resources from your Vue.js client application.
Next Steps
You have implemented user authentication in Vue.js to identify your users, get user profile information, and control the content that your users can access by protecting routes and API resources.
This guide covered the most common authentication use case for a Vue.js application: simple login and logout. However, Auth0 is an extensible and flexible identity platform that can help you achieve even more. If you have a more complex use case, check out the Auth0 Architecture Scenarios to learn more about the typical architecture scenarios we have identified when working with customers on implementing Auth0.
We'll cover advanced authentication patterns and tooling in future guides, such as using a pop-up instead of redirecting users to log in, adding permissions to ID tokens, using metadata to enhance user profiles, and much more.

Angular Authentication By Example
This TypeScript guide will help you learn how to secure an Angular application using token-based authentication. You'll learn how to use the Angular framework to implement the following security features:
- How to add user login, sign-up, and logout to Angular Applications.
- How to create route guards to protect Angular application routes.
- How to make API calls from Angular to request data from a protected API.
- How to get user profile information to personalize an Angular user interface.
This guide uses the Auth0 Angular SDK, which provides developers with a high-level API to handle many authentication implementation details. You can now secure your Angular applications following security best practices while writing less code.
Quick Angular Setup
With the help of Auth0, you don't need to be an expert on identity protocols, such as OAuth 2.0 or OpenID Connect, to understand how to secure your web application stack.
You first integrate your Angular application with Auth0. Your application will then redirect users to an Auth0 customizable login page when they need to log in. Once your users log in successfully, Auth0 redirects them back to your Angular app, returning JSON Web Tokens (JWTs) with their authentication and user information.
Get the Angular Starter Application
We have created a starter project using the Angular CLI to help you learn Angular security concepts through hands-on practice. You can focus on building Angular components and services to secure your application.
Start by cloning the spa_angular_typescript_hello-world
repository on its starter
branch:
git clone -b starter [email protected]:auth0-developer-hub/spa_angular_typescript_hello-world.git
Once you clone the repo, make spa_angular_typescript_hello-world
your current directory:
cd spa_angular_typescript_hello-world
Install the Angular project dependencies as follows:
npm install
This starter Angular project offers a functional application that consumes data from an external API to hydrate the user interface. For simplicity and convenience, the starter project simulates the external API locally using json-server
. Later on, you'll integrate this Angular application with a real API server using a backend technology of your choice.
The compatible API server runs on http://localhost:6060
by default. As such, to connect your Angular application with that API server, create a .env
file under the root project directory:
touch .env
Populate .env
with the following environment variables:
API_SERVER_URL=http://localhost:6060
This project uses an npm script to integrate the content of the .env
file with the Angular framework. Check out the set-env.ts
file:
const { writeFile } = require('fs');const { promisify } = require('util');const dotenv = require('dotenv');dotenv.config();const writeFilePromisified = promisify(writeFile);const targetPath = './src/environments/environment.ts';const envConfigFile = `export const environment = {production: false,api: {serverUrl: '${process.env['API_SERVER_URL']}',},};`;(async () => {try {await writeFilePromisified(targetPath, envConfigFile);} catch (err) {console.error(err);throw err;}})();
This script uses the dotenv
package to load environment variables from a .env
file into process.env
. The script then uses a string template to create the content of the ./src/environments/environment.ts
file. It then writes that file with the prescribed content into the Angular project.
The env
npm script defined in package.json
runs the set-env.ts
script using ts-node
. However, you don't have to execute npm run env
directly. The start
npm script will run that for you before you start the Angular development server.
As such, execute the following command to run the Angular application:
npm start
Next, execute the following command to run the JSON server API:
npm run api
You are ready to start implementing user authentication in this Angular project. First, you'll need to configure the Angular application to connect successfully to Auth0. Afterward, you'll use the Auth0 Angular SDK to protect routes, display user profile information, and request protected data from an external API server to hydrate some of the application pages.
Configure Angular with Auth0
Follow these steps to get started with the Auth0 Identity Platform quickly:
Sign up and create an Auth0 Application
A free account also offers you:
- Auth0 Universal Login for Web, iOS & Android.
- Up to 2 social identity providers like Google, GitHub, and Twitter.
- Up to 3 Actions, Rules, & Hooks to customize and extend Auth0's capabilities.
During the sign-up process, you create something called an Auth0 Tenant, representing the product or service to which you are adding authentication.
Once you sign in, Auth0 takes you to the Dashboard. In the left sidebar menu, click on "Applications".
Then, click the "Create Application" button. A modal opens up with a form to provide a name for the application and choose its type. Use the following values:
Auth0 Angular Code Sample
Click the "Create" button to complete the process. Your Auth0 application page loads up.
In the next step, you'll learn how to help Angular and Auth0 communicate.
What's the relationship between Auth0 Tenants and Auth0 Applications?
Let's say that you have a photo-sharing Angular app called "NG-Gram". You then would create an Auth0 tenant called ng-gram
. From a customer perspective, NG-Gram is that customer's product or service.
Now, say that NG-Gram is available on three platforms: web as a single-page application and Android and iOS as a native mobile application. If each platform needs authentication, you need to create three Auth0 applications to provide the product with everything it needs to authenticate users through that platform.
NG-Gram users belong to the Auth0 NG-Gram tenant, which shares them across its Auth0 applications.
Create a communication bridge between Angular and Auth0
When using the Auth0 Identity Platform, you don't have to build login forms. Auth0 offers a Universal Login Page to reduce the overhead of adding and managing authentication.
How does Universal Login work?
Your Angular application will redirect users to Auth0 whenever they trigger an authentication request. Auth0 will present them with a login page. Once they log in, Auth0 will redirect them back to your Angular application. For that redirecting to happen securely, you must specify in your Auth0 Application Settings the URLs to which Auth0 can redirect users once it authenticates them.
As such, click on the "Settings" tab of your Auth0 Application page, locate the "Application URIs" section, and fill in the following values:
http://localhost:4040/callback
The above value is the URL that Auth0 can use to redirect your users after they successfully log in.
http://localhost:4040
The above value is the URL that Auth0 can use to redirect your users after they log out.
http://localhost:4040
Using the Auth0 Angular SDK, your Angular application will make requests under the hood to an Auth0 URL to handle authentication requests. As such, you need to add your Angular application origin URL to avoid Cross-Origin Resource Sharing (CORS) issues.
Scroll down and click the "Save Changes" button.
Do not close this page yet. You'll need some of its information in the next section.
Add the Auth0 configuration variables to Angular
From the Auth0 Application Settings page, you need the Auth0 Domain and Client ID values to allow your Angular application to use the communication bridge you created.
What exactly is an Auth0 Domain and an Auth0 Client ID?
Domain
When you created a new Auth0 account, Auth0 asked you to pick a name for your tenant. This name, appended with auth0.com
, is your Auth0 Domain. It's the base URL that you will use to access the Auth0 APIs and the URL where you'll redirect users to log in.
Client ID
Each application is assigned a Client ID upon creation, which is an alphanumeric string, and it's the unique identifier for your application (such as q8fij2iug0CmgPLfTfG1tZGdTQyGaTUA
). You cannot modify the Client ID. You will use the Client ID to identify the Auth0 Application to which the Auth0 SPA SDK needs to connect.
Warning: Another critical piece of information present in the "Settings" is the Client Secret. This secret protects your resources by only granting tokens to requestors if they're authorized. Think of it as your application's password, which must be kept confidential at all times. If anyone gains access to your Client Secret, they can impersonate your application and access protected resources.
Head back to your Auth0 application page and click on the "Settings" tab.
Locate the "Basic Information" section and follow these steps to get the Auth0 Domain and Auth0 Client ID values:
When you enter a value in the input fields present on this page, any code snippet that uses such value updates to reflect it. Using the input fields makes it easy to copy and paste code as you follow along.
As such, enter the "Domain" and "Client ID" values in the following fields to set up your single-page application in the next section:
These variables let your Angular application identify itself as an authorized party to interact with the Auth0 authentication server.
Now, update the .env
file under the Angular project directory as follows:
API_SERVER_URL=http://localhost:6060AUTH0_DOMAIN=AUTH0-DOMAINAUTH0_CLIENT_ID=AUTH0-CLIENT-IDAUTH0_CALLBACK_URL=http://localhost:4040/callback
Once you reach the "Call a Protected API from Angular" section of this guide, you'll learn how to use API_SERVER_URL
along with an Auth0 Audience value to request protected resources from an external API that is also protected by Auth0. For now, the application is using json-server
to mock the API.
Update the set-env.ts
script file to integrate these new Auth0 environment variables from .env
into your Angular src/environments/environment.ts
file:
const { writeFile } = require('fs');const { promisify } = require('util');const dotenv = require('dotenv');dotenv.config();const writeFilePromisified = promisify(writeFile);const targetPath = './src/environments/environment.ts';const envConfigFile = `export const environment = {production: false,auth0: {domain: '${process.env['AUTH0_DOMAIN']}',clientId: '${process.env['AUTH0_CLIENT_ID']}',authorizationParams: {redirect_uri: '${process.env['AUTH0_CALLBACK_URL']}',},},api: {serverUrl: '${process.env['API_SERVER_URL']}',},};`;(async () => {try {await writeFilePromisified(targetPath, envConfigFile);} catch (err) {console.error(err);throw err;}})();
You're creating an auth0
object using the configuration values from the Auth0 application you created in the Auth0 Dashboard: Auth0 Domain and Client ID.
Additionally, you use the authorizationParams
configuration object to define the query parameters that Angular needs to include on its calls to the Auth0 /authorize
endpoint. You define the redirect_uri
property within this object to specify the URL from your Angular application to where Auth0 should redirect your users after they successfully log in.
Later, you'll use the auth0
object propierties to configure the AuthModule
from the Auth0 Angular SDK using the forRoot()
pattern.
Restart your Angular development server to re-generate the src/environments/environment.ts
file:
npm start
Handle the Auth0 post-login behavior
Notice that the Auth0 Callback URL, AUTH0_CALLBACK_URL
, points to http://localhost:4040/callback
, which is the URL that Auth0 uses to redirect your users after they successfully log in. For this Angular application, you'll render a simple page component for the /callback
route.
Start by creating a CallbackModule
file under the src/app/features
directory using the Angular CLI:
ng g module features/callback --routing
Next, use the Angular CLI to create a CallbackComponent
under the src/app/features/callback
directory and declare it in the CallbackModule
:
ng g component features/callback --module=features/callback/callback.module.ts --skip-tests --style=none
Update the CallbackModule
to include the SharedModule
in its imports
array:
import { NgModule } from '@angular/core';import { CommonModule } from '@angular/common';import { SharedModule } from '@app/shared';import { CallbackComponent } from './callback.component';import { CallbackRoutingModule } from './callback-routing.module';@NgModule({declarations: [CallbackComponent],imports: [CommonModule, SharedModule, CallbackRoutingModule],})export class CallbackModule {}
Update the CallbackRoutingModule
to set CallbackComponent
as the default route:
import { NgModule } from '@angular/core';import { RouterModule, Routes } from '@angular/router';import { CallbackComponent } from './callback.component';const routes: Routes = [{path: "",component: CallbackComponent,}];@NgModule({imports: [RouterModule.forChild(routes)],exports: [RouterModule]})export class CallbackRoutingModule { }
Populate the src/app/features/callback/callback.component.html
template file as follows:
<div class="page-layout"><app-nav-bar></app-nav-bar><app-mobile-nav-bar></app-mobile-nav-bar><div class="page-layout__content"><ng-content></ng-content></div></div>
The CallbackComponent
will only render the navigation bar and an empty content container to help you create a smooth transition between a route with no content, /callback
, to a route with content, such as the /profile
page.
The next step is to lazy-load your CallbackModule
using the Angular router.
Locate the src/app/app-routing.module.ts
file and update it like so:
import { NgModule } from '@angular/core';import { RouterModule, Routes } from '@angular/router';const routes: Routes = [{path: '',pathMatch: 'full',loadChildren: () =>import('./features/home/home.module').then((m) => m.HomeModule),},{path: 'profile',loadChildren: () =>import('./features/profile/profile.module').then((m) => m.ProfileModule),},{path: 'public',loadChildren: () =>import('./features/public/public.module').then((m) => m.PublicModule),},{path: 'protected',loadChildren: () =>import('./features/protected/protected.module').then((m) => m.ProtectedModule),},{path: 'admin',loadChildren: () =>import('./features/admin/admin.module').then((m) => m.AdminModule),},{path: 'callback',loadChildren: () =>import('./features/callback/callback.module').then((m) => m.CallbackModule),},{path: '**',loadChildren: () =>import('./features/not-found/not-found.module').then((m) => m.NotFoundModule),},];@NgModule({imports: [RouterModule.forRoot(routes)],exports: [RouterModule],})export class AppRoutingModule {}
What are the benefits of using a callback page?
Implementing a page that specializes in handling the user redirection from the Auth0 Universal Login Page to your application (the callback event) has some benefits:
- Your users won't see any flashing of the home page component, which renders at the root path,
/
. - By showing the navigation bar in the
/callback
route, your user may feel that your Angular application loads fast. - By not showing the footer, your users may feel that your Angular application loads smoothly.
- You can avoid making unnecessary or costly API calls that may run when loading your home page components.
Once you add a login and logout button to this app, you can verify this user experience improvement by using your browser's developer tools. In the case of Google Chrome, you could do the following:
- Configure Chrome to emulate slow network connections to observe how the application loads after logging in.
- Record the runtime performance of your Angular application. Once done, observe the rendering order of pages and elements in the timeline Chrome produces.
If you are not convinced yet, let's explore more details on the impact of this strategy.
Imagine that you want to redirect your users to the /profile
after they log in. If you were to use the root URL of your Angular application, http://localhost:4040
, as the Auth0 Callback URL, you may hurt the user experience when the user's connection is slow or when you are lazy loading the /profile
route:
- This Angular application offers a
/profile
page that will display user profile information such as name and email address. However, this application also lazy loads that/profile
route using the Angular Router. - Since user profile information is private, it must be protected against unauthorized access.
- The Auth0 Angular SDK allows you to easily require users to log in before they can access a route.
- When a user who is not logged in clicks on the
/profile
page navigation tab, Auth0 will redirect them to a page to log in. - Once your users log in, Auth0 will redirect them to your Angular application with some metadata that allows your application to redirect them to the protected page they intended to access.
- When you use
http://localhost:4040
as the Auth0 Callback URL, Auth0 will redirect your users to the home page first. Depending on how fast your application renders pages and handles redirects, your users may see the home page first before Angular takes them to the/profile
page when the connection is slow or when you are lazy loading that route. This quick re-routing makes your user interface "flash", which makes the user interface feel janky or glitchy. - However, when you use
http://localhost:4040/callback
as the Auth0 Callback URL, Auth0 will take your users to a/callback
route after they log in. You can then display a loading animation or nothing at all in that special route. Doing so makes the transition from/callback
to/profile
smoother as no unrelated or unexpected content shows up in the process.
Additionally, when you load the home page, /
, you may trigger logic that fetches data from an external API or runs any other business logic related to hydrating the home page. If your intention is to show the users a /profile
page after they log in, there's no need or value to run any of that home page business logic that won't impact the rendering of the /profile
page. Instead, you may increase your operational costs by running unnecessary logic when any of your users log in. In that case, it's better to handle the Auth0 redirect in a minimal and performant specialized route, /callback
.
Install and Set Up the Auth0 Angular SDK
Execute the following command to install the Auth0 Angular SDK:
npm install --save @auth0/auth0-angular
The Auth0 Angular SDK exposes several methods, variables, and types that help you integrate Auth0 with your Angular application idiomatically, including an authentication module and service.
Update the src/app/app.module.ts
file as follows to import the AuthModule
from the Auth0 Angular SDK into your AppModule
and configure it using data from your environment
module:
import { HttpClientModule } from '@angular/common/http';import { NgModule } from '@angular/core';import { BrowserModule } from '@angular/platform-browser';import { AuthModule } from '@auth0/auth0-angular';import { environment as env } from '../environments/environment';import { AppRoutingModule } from './app-routing.module';import { AppComponent } from './app.component';@NgModule({declarations: [AppComponent],imports: [BrowserModule,AppRoutingModule,HttpClientModule,AuthModule.forRoot({...env.auth0,}),],bootstrap: [AppComponent],})export class AppModule {}
You use the forRoot()
pattern to configure AuthModule
, which takes an object with the domain
, clientId
, and authorizationParams
properties. You create that configuration object by spreading the env.auth
object.
User authentication is a mechanism to control who can access your application. You can integrate your Angular application with Auth0 to prevent users who have not logged in from accessing a /profile
or /admin
route.
If users want to access a guarded route from your application, Auth0 will stop them and ask them to present their credentials. If Auth0 can verify who they are and that they are supposed to go in there, Auth0 will let them in.
The authentication process won't happen within your Angular application layer when using Auth0. Your Angular application will redirect your users to the Auth0 Universal Login page, where Auth0 asks them for credentials and redirects them back to your application with the result of the authentication process.
Auth0 and Angular connection set
You have completed setting up an authentication module that your Angular application can consume. All that is left is for you to continue building up the starter project throughout this guide by implementing Angular components that trigger and manage the authentication flow.
Feel free to dive deeper into the Auth0 Documentation to learn more about how Auth0 helps you save time implementing and managing identity.
Add User Login to Angular
The steps on how to build an Angular login form or login page are complex. You can save development time by using a login page hosted by Auth0 that has a built-in login form that supports different types of user authentication: username and password, social login, and Multi-Factor Authentication (MFA). You just need to create a button that takes users from your Angular application to the login page.
Start by generating a LoginButtonComponent
file under the src/app/shared/components/buttons
directory and register it the SharedModule
using the Angular CLI:
ng g component shared/components/buttons/login-button --module=shared/shared.module.ts --inline-template --skip-tests --style=none --flat --export
Populate src/app/shared/components/buttons/login-button.component.ts
like so:
import { Component } from '@angular/core';import { AuthService } from '@auth0/auth0-angular';@Component({selector: 'app-login-button',template: `<button class="button__login" (click)="handleLogin()">Log In</button>`,})export class LoginButtonComponent {constructor(private auth: AuthService) {}handleLogin(): void {this.auth.loginWithRedirect({appState: {target: '/profile',},});}}
Within the LoginButtonComponent
definition, this.auth.loginWithRedirect()
is a method exposed by AuthService
that performs a redirect to the Auth0 /authorize
endpoint to kickstart the authentication process. You can pass a configuration object to this method to customize the login experience.
By setting up the value of appState.target
to /profile
, you are telling the Auth0 Angular SDK the following: When my users log in with Auth0 and return to my Angular application, take them from the default callback URL path, /callback
, to the "Profile" page, /profile
. If you don't specify this appState.returnTo
option, your users will be redirected by default to the /
path after they log in.
In the next section, you'll configure this method to create a button that your users can click on to sign up for your application.
Add User Sign-Up to Angular
The process on how to build an Angular sign-up form is much more complex. However, you can use a sign-up form hosted by Auth0 that has a built-in password strength verification.
You can create a button that takes users from your Angular application to the sign-up page by specifying the screen_hint=signup
property in the authorizationParams
configuration object of the loginWithRedirect()
method:
authorizationParams: {screen_hint: "signup",}
This loginWithRedirect()
method is a wrapper from the Auth0 SPA SDK method of the same name. As such, you can use the RedirectLoginOptions
document from the Auth0 SPA SDK to learn more details on these configuration options.
To see this in practice, generate a SignupButtonComponent
file under the src/app/shared/components/buttons
directory and register it with the SharedModule
using the Angular CLI:
ng g component shared/components/buttons/signup-button --module=shared/shared.module.ts --inline-template --skip-tests --style=none --flat --export
Populate src/app/shared/components/buttons/signup-button.component.ts
like so to define a sign-up button component:
import { Component } from '@angular/core';import { AuthService } from '@auth0/auth0-angular';@Component({selector: 'app-signup-button',template: `<button class="button__sign-up" (click)="handleSignUp()">Sign Up</button>`,})export class SignupButtonComponent {constructor(private auth: AuthService) {}handleSignUp(): void {this.auth.loginWithRedirect({appState: {target: '/profile',},authorizationParams: {screen_hint: 'signup',},});}}
Using the Auth0 Signup feature requires you to enable the Auth0 New Universal Login Experience in your tenant.
Open the Universal Login section of the Auth0 Dashboard and choose the "New" option under the "Experience" subsection.
Scroll down and click on the "Save Changes" button.
The difference between the login and sign-up user experience will be more evident once you integrate those components with your Angular application and see them in action. You'll do that in the following sections.
Add User Logout to Angular
You can log out users from your Angular application by logging them out of their Auth0 sessions using the logout()
method from the Auth0 Angular SDK.
Generate a LogoutButtonComponent
file under the src/app/shared/components/buttons
directory and register it the SharedModule
using the Angular CLI:
ng g component shared/components/buttons/logout-button --module=shared/shared.module.ts --inline-template --skip-tests --style=none --flat --export
Populate src/app/shared/components/buttons/logout-button.component.ts
like so:
import { Component, Inject } from '@angular/core';import { DOCUMENT } from '@angular/common';import { AuthService } from '@auth0/auth0-angular';@Component({selector: 'app-logout-button',template: `<button class="button__logout" (click)="handleLogout()">Log Out</button>`,})export class LogoutButtonComponent {constructor(private auth: AuthService,@Inject(DOCUMENT) private doc: Document) {}handleLogout(): void {this.auth.logout({logoutParams: {returnTo: this.doc.location.origin,},});}}
When using the logout()
method, the Auth0 Angular SDK clears the application session and redirects to the Auth0 /v2/logout
endpoint to clear the Auth0 session under the hood.
As with the login method, you can pass an object argument to logout()
to customize the logout behavior of the Angular application. You can define a logoutParams
property on that configuration object to define parameters for the /v2/logout
call. This process is fairly invisible to the user. See logoutParams
for more details on the parameters available.
Here, you pass the logoutParams.returnTo
option to specify the URL where Auth0 should redirect your users after they log out. Right now, you are working locally, and your Auth0 application's "Allowed Logout URLs" points to http://localhost:4040
.
However, if you were to deploy your Angular application to production, you need to add the production logout URL to the "Allowed Logout URLs" list and ensure that Auth0 redirects your users to that production URL and not localhost
. Setting logoutParams.returnTo
to window.location.origin
will do just that.
A best practice when working with Auth0 is to have different tenants for your different project environments. For example, it's recommended for developers to specify a production tenant. A production tenant gets higher rate limits than non-production tenants. Check out the "Set Up Multiple Environments" Auth0 document to learn more about how to set up development, staging, and production environments in the Auth0 Identity Platform.
Render Components Conditionally
In this section, you'll learn how to render Angular components conditionally based on the status of the Auth0 Angular SDK or the authentication status of your users.
Render the authentication buttons conditionally
The Angular starter application features a desktop and mobile navigation experience.
When using your Angular application on a viewport large enough to fix a desktop or tablet experience, you'll see a navigation bar at the top of the page.
When using a viewport that fits the screen constraints of a mobile device, you'll see a menu button at the top-right corner of the page. Tapping or clicking on the menu button opens a modal that shows you the different pages that you can access in the application.
In this section, you'll expose the button components that trigger the login, sign-up, and logout events through these page navigation elements.
Let's start with the desktop navigation user experience. You'll show both the login and sign-up buttons on the navigation bar when the user is not logged in. Naturally, you'll show the logout button when when the user is logged in.
Create an isAuthenticated$
variable in the NavBarButtonsComponent
to implement the user experience defined above:
import { Component } from '@angular/core';import { AuthService } from "@auth0/auth0-angular";@Component({selector: 'app-nav-bar-buttons',templateUrl: './nav-bar-buttons.component.html',})export class NavBarButtonsComponent {isAuthenticated$ = this.authService.isAuthenticated$constructor(private authService: AuthService) {}}
Next, update the src/app/shared/components/navigation/desktop/nav-bar-buttons.component.html
as follows to conditionally show and hide login, sign-up, and logout buttons:
<div class="nav-bar__buttons"><ng-container *ngIf="isAuthenticated$ | async; else unAuthenticated"><app-logout-button></app-logout-button></ng-container><ng-template #unAuthenticated><app-signup-button></app-signup-button><app-login-button></app-login-button></ng-template></div>
Auth0's isAuthenticated$
value reflects the authentication state of your users as tracked by the Auth0 Angular SDK plugin. This value is true
when the user has been authenticated and false
when not. As such, you can use the isAuthenticated$
observable to render UI elements conditionally depending on the authentication state of your users, as you did above.
The mobile navigation experience works in the same fashion, except that the authentication-related buttons are tucked into the mobile menu modal.
Update src/app/shared/components/navigation/mobile/mobile-nav-bar-buttons.component.ts
as follows:
import { Component } from '@angular/core';import { AuthService } from "@auth0/auth0-angular";@Component({selector: 'app-mobile-nav-bar-buttons',templateUrl: './mobile-nav-bar-buttons.component.html',})export class MobileNavBarButtonsComponent {isAuthenticated$ = this.authService.isAuthenticated$constructor(private authService: AuthService) {}}
Next, update the src/app/shared/components/navigation/mobile/mobile-nav-bar-buttons.component.html
as follows to conditionally show and hide login, sign-up, and logout buttons:
<div class="mobile-nav-bar__buttons"><ng-container *ngIf="isAuthenticated$ | async; else unAuthenticated"><app-logout-button></app-logout-button></ng-container><ng-template #unAuthenticated><app-signup-button></app-signup-button><app-login-button></app-login-button></ng-template></div>
Go ahead and try to log in. Your Angular application redirects you to the Auth0 Universal Login page. You can use the form to log in with a username and password or a social identity provider like Google. Notice that this login page also gives you the option to sign up.
However, when you click the sign-up button from your application directly, Angular takes you to the Signup page, where your users can sign up for the Angular application. Try it out!
Notice that when you finish logging in or signing up, Auth0 redirects you to your Angular app, but the login and sign-up buttons may briefly show up before the logout button renders. You'll fix that next.
Render the application conditionally
The user interface flashes because your Angular app doesn't know if Auth0 has authenticated the user yet. Your Angular application will know the user authentication status after the Auth0 Angular SDK initializes.
To fix that UI flashing, use the isLoading$
observable exposed by the AuthService
that emits a boolean value to render a loader in the AppComponent
until the Auth0 Angular SDK has finished loading.
Start with importing the SharedModule
into the AppModule
:
import { HttpClientModule } from '@angular/common/http';import { NgModule } from '@angular/core';import { BrowserModule } from '@angular/platform-browser';import { AuthModule } from '@auth0/auth0-angular';import { environment as env } from '../environments/environment';import { AppRoutingModule } from './app-routing.module';import { AppComponent } from './app.component';import { SharedModule } from './shared';@NgModule({declarations: [AppComponent],imports: [BrowserModule,AppRoutingModule,HttpClientModule,SharedModule,AuthModule.forRoot({...env.auth0,}),],bootstrap: [AppComponent],})export class AppModule {}
Next, open src/app/app.component.ts
and assign Auth0's isLoading$
observable to a variable:
import { Component } from '@angular/core';import { AuthService } from "@auth0/auth0-angular";@Component({selector: 'app-root',templateUrl: './app.component.html',})export class AppComponent {isAuth0Loading$ = this.authService.isLoading$;constructor(private authService: AuthService) {}}
Open src/app/app.component.html
and update it as follows:
<div class="page-layout" *ngIf="isAuth0Loading$ | async; else auth0Loaded"><app-page-loader></app-page-loader></div><ng-template #auth0Loaded><router-outlet></router-outlet></ng-template>
While the SDK is loading, the PageLoaderComponent
renders, which shows up an animation. Log out and log back in to see this in action. No more UI flashing should happen.
Render navigation tabs conditionally
There may be use cases where you want to hide user interface elements from users who have not logged in to your application. For this starter application, only authenticated users should see the navigation tabs to access the /protected
and /admin
pages.
To implement this use case, you'll rely once again on the isAuthenticated$
Observable from the AuthService
.
Open the src/app/shared/components/navigation/desktop/nav-bar-tabs.component.ts
component file that defines your desktop navigation tabs and update it like so:
import { Component } from '@angular/core';import { AuthService } from '@auth0/auth0-angular';@Component({selector: 'app-nav-bar-tabs',templateUrl: './nav-bar-tabs.component.html',})export class NavBarTabsComponent {isAuthenticated$ = this.authService.isAuthenticated$;constructor(private authService: AuthService) {}}
Open the src/app/shared/components/navigation/desktop/nav-bar-tabs.component.html
component file and update it as follows:
<div class="nav-bar__tabs"><app-nav-bar-tab path="/profile" label="Profile"></app-nav-bar-tab><app-nav-bar-tab path="/public" label="Public"></app-nav-bar-tab><ng-container *ngIf="isAuthenticated$ | async"><app-nav-bar-tab path="/protected" label="Protected"></app-nav-bar-tab><app-nav-bar-tab path="/admin" label="Admin"></app-nav-bar-tab></ng-container></div>
Next, open the src/app/shared/components/navigation/mobile/mobile-nav-bar-tabs.component.ts
component file that defines your mobile navigation tabs and update it like so:
import { Component, EventEmitter, Output } from '@angular/core';import { AuthService } from '@auth0/auth0-angular';@Component({selector: 'app-mobile-nav-bar-tabs',templateUrl: './mobile-nav-bar-tabs.component.html',})export class MobileNavBarTabsComponent {@Output() mobileNavBarTabClick = new EventEmitter<string>();isAuthenticated$ = this.auth.isAuthenticated$;constructor(private auth: AuthService) {}onMobileNavBarTabClick(path: string): void {this.mobileNavBarTabClick.emit(path);}}
Open the src/app/shared/components/navigation/mobile/nav-bar-tabs.component.html
component file and update it as follows:
<div class="mobile-nav-bar__tabs"><app-mobile-nav-bar-tabpath="/profile"label="Profile"(mobileNavBarTabClick)="onMobileNavBarTabClick($event)"></app-mobile-nav-bar-tab><app-mobile-nav-bar-tabpath="/public"label="Public"(mobileNavBarTabClick)="onMobileNavBarTabClick($event)"></app-mobile-nav-bar-tab><ng-container *ngIf="isAuthenticated$ | async"><app-mobile-nav-bar-tabpath="/protected"label="Protected"(mobileNavBarTabClick)="onMobileNavBarTabClick($event)"></app-mobile-nav-bar-tab><app-mobile-nav-bar-tabpath="/admin"label="Admin"(mobileNavBarTabClick)="onMobileNavBarTabClick($event)"></app-mobile-nav-bar-tab></ng-container></div>
Log out from your Angular application and notice how now you can only see the tabs for the /profile
and /public
pages in the navigation bar, along with the login and sign-up buttons. Log in and then see the rest of the navigation bar show up.
Keep in mind that this does not restrict access to the /admin
and /protected
pages at all. You'll learn how to use the Auth0 Angular SDK to protect Angular routes in the next section.
Add Route Guards to Angular
You can create an authentication route guard to protect Angular routes. Angular will ask users who visit the route to log in if they haven't already. Once they log in, Angular takes them to the route they tried to access.
You can apply a guard to any route defined in the Angular router module by updating src/app/app-routing.module.ts
as follows:
import { NgModule } from '@angular/core';import { RouterModule, Routes } from '@angular/router';import { AuthGuard } from '@auth0/auth0-angular';const routes: Routes = [{path: '',pathMatch: 'full',loadChildren: () =>import('./features/home/home.module').then((m) => m.HomeModule),},{path: 'profile',loadChildren: () =>import('./features/profile/profile.module').then((m) => m.ProfileModule),canActivate: [AuthGuard],},{path: 'public',loadChildren: () =>import('./features/public/public.module').then((m) => m.PublicModule),},{path: 'protected',loadChildren: () =>import('./features/protected/protected.module').then((m) => m.ProtectedModule),canActivate: [AuthGuard],},{path: 'admin',loadChildren: () =>import('./features/admin/admin.module').then((m) => m.AdminModule),canActivate: [AuthGuard],},{path: 'callback',loadChildren: () =>import('./features/callback/callback.module').then((m) => m.CallbackModule),},{path: '**',loadChildren: () =>import('./features/not-found/not-found.module').then((m) => m.NotFoundModule),},];@NgModule({imports: [RouterModule.forRoot(routes)],exports: [RouterModule],})export class AppRoutingModule {}
You use the AuthGuard
from the Auth0 Angular SDK to protect the /profile
, /protected
, and /admin
routes by adding it as the value of the canActivate
route configuration property.
If the conditions defined by AuthGuard
pass, the component renders. Otherwise, AuthGuard
instructs Angular to take you to the Auth0 Universal Login Page to authenticate.
You can now test that these guarded paths require users to log in before accessing them. Log out and try to access the Profile page, Protected page, or the Admin page. If it works, Angular redirects you to log in with Auth0.
Once you log in, Angular should take you to the /profile
page as specified by the appState.target
property present in the login button component definition.
Client-side guards improve the user experience of your Angular application, not its security.
In Security StackExchange, Conor Mancone explains that server-side guards are about protecting data while client-side guards are about improving user experience.
The main takeaways from his response are:
- You can't rely on client-side restrictions, such as navigation guards and protected routes, to protect sensitive information.
- Attackers can potentially get around client-side restrictions.
- Your server should not return any data that a user should not access.
The wrong approach is to return all the user data from the server and let the front-end framework decide what to display and what to hide based on the user authentication status.
- Anyone can open the browser's developer tools and inspect the network requests to view all the data.
- The use of navigation guards helps improve user experience, not user security.
- Without guards, a user who has not logged in may wander into a page with restricted information and see an error like "Access Denied".
- With guards that match the server permissions, you can prevent users from seeing errors by preventing them from visiting the restricted page.
Get User Profile Information in Angular
After a user successfully logs in, Auth0 sends an ID token to your Angular application. Authentication systems, such as Auth0, use ID Tokens in token-based authentication to cache user profile information and provide it to a client application. The caching of ID tokens can improve the performance and responsiveness of your Angular application.
You can use the data from the ID token to personalize the user interface of your Angular application. The Auth0 Angular SDK decodes the ID token and stores its data in the user$
Observable exposed via the AuthService
. Some of the ID token information includes the name, nickname, picture, and email of the logged-in user.
How can you use the ID token to create a profile page for your users?
Update src/app/features/profile/profile.component.ts
as follows:
import { Component } from '@angular/core';import { AuthService } from '@auth0/auth0-angular';import { map } from 'rxjs/operators';@Component({selector: 'app-profile',templateUrl: './profile.component.html',})export class ProfileComponent {title = 'Decoded ID Token';user$ = this.authService.user$;code$ = this.user$.pipe(map((user) => JSON.stringify(user, null, 2)));constructor(private authService: AuthService) {}}
Next, update src/app/features/profile/profile.component.html
as follows:
<app-page-layout><div class="content-layout"><h1 id="page-title" class="content__title">Profile Page</h1><div class="content__body"><p id="page-description"><span>You can use the <strong>ID Token</strong> to get the profileinformation of an authenticated user.</span><span><strong>Only authenticated users can access this page.</strong></span></p><ng-container *ngIf="user$ | async as user"><div class="profile-grid"><div class="profile__header"><img [src]="user.picture" alt="Profile" class="profile__avatar" /><div class="profile__headline"><h2 class="profile__title">{{ user.name }}</h2><span class="profile__description">{{ user.email }}</span></div></div><ng-container *ngIf="code$ | async as code"><div class="profile__details"><app-code-snippet[title]="title"[code]="code"></app-code-snippet></div></ng-container></div></ng-container></div></div></app-page-layout>
What's happening within the ProfileComponent
?
-
You display three properties from the
user
object in the user interface:name
,picture
, andemail
. -
Since the data comes from an Observable, you can subscribe to it directly in the template via the
async
pipe. -
Finally, you display the full content of the decoded ID token within a code box. You can now see all the other properties available for you to use. The properties are known as "token claims".
The ProfileComponent
renders user information that you could consider private or sensitive. Additionally, the user
property is null
if there is no logged-in user. So either way, this component should only render if Auth0 has authenticated the user. You are already restricting access to this page component by using the authGuard
in the /profile
route definition of your Angular router module, src/app/app-routing.module.ts
.
If you are logged in to your application, visit http://localhost:4040/profile
to see your user profile details.
Integrate Angular with an API Server
This section focuses on showing you how to get an access token in your Angular application and how to use it to make API calls to protected API endpoints.
When you use Auth0, you delegate the authentication process to a centralized service. Auth0 provides you with functionality to log in and log out users from your Angular application. However, your application may need to access protected resources from an API.
You can also protect an API with Auth0. There are multiple API quickstarts to help you integrate Auth0 with your backend platform.
When you use Auth0 to protect your API, you also delegate the authorization process to a centralized service that ensures only approved client applications can access protected resources on behalf of a user.
How can you make secure API calls from Angular?
Your Angular application authenticates the user and receives an access token from Auth0. The application can then pass that access token to your API as a credential. In turn, your API can use Auth0 libraries to verify the access token it receives from the calling application and issue a response with the desired data.
Instead of creating an API from scratch to test the authentication and authorization flow between the client and the server, you can pair this client application with an API server that matches the technology stack you use at work. The Angular "Hello World" client application that you have been building up can interact with any of the "Hello World" API server samples from the Auth0 Developer Hub.
The "Hello World" API server samples run on http://localhost:6060
by default, which is the same origin URL and port where the mocked JSON server is running. As such, before you set up the "Hello World" API server, locate the tab where you are running the npm run api
command and stop the mocked JSON server.
Pick an API code sample in your preferred backend framework and language from the list below and follow the instructions on the code sample page to set it up. Once you complete the sample API server setup, please return to this page to learn how to integrate that API server with your Angular application.
Call a Protected API from Angular
Once you have set up the API server code sample, you should have created an Auth0 Audience value. Store that value in the following field so that you can use it throughout the instructions presented on this page easily:
Now, update the .env
file under the Angular project directory as follows:
API_SERVER_URL=http://localhost:6060AUTH0_DOMAIN=AUTH0-DOMAINAUTH0_CLIENT_ID=AUTH0-CLIENT-IDAUTH0_CALLBACK_URL=http://localhost:4040/callbackAUTH0_AUDIENCE=AUTH0-AUDIENCE
You are using AUTH0_AUDIENCE
to add the value of your Auth0 API Audience so that your Angular client application can request resources from the API that such audience value represents.
Let's understand better what the AUTH0_AUDIENCE
and API_SERVER_URL
values represent.
The API_SERVER_URL
is simply the URL where your sample API server listens for requests. In production, you'll change this value to the URL of your live server.
Your Angular application must pass an access token when it calls a target API to access protected resources. You can request an access token in a format that the API can verify by passing the audience
to the Auth0 Angular SDK.
The value of the Auth0 Audience must be the same for both the Angular client application and the API server you decided to set up.
Why is the Auth0 Audience value the same for both apps? Auth0 uses the value of the audience
prop to determine which resource server (API) the user is authorizing your Angular application to access. It's like a phone number. You want to ensure that your Angular application "texts the right API".
As such, update the set-env.ts
script file to integrate these new Auth0 environment variables from .env
into your Angular src/environments/environment.ts
file:
const { writeFile } = require('fs');const { promisify } = require('util');const dotenv = require('dotenv');dotenv.config();const writeFilePromisified = promisify(writeFile);const targetPath = './src/environments/environment.ts';const envConfigFile = `export const environment = {production: false,auth0: {domain: '${process.env['AUTH0_DOMAIN']}',clientId: '${process.env['AUTH0_CLIENT_ID']}',authorizationParams: {audience: '${process.env['AUTH0_AUDIENCE']}',redirect_uri: '${process.env['AUTH0_CALLBACK_URL']}',},},api: {serverUrl: '${process.env['API_SERVER_URL']}',},};`;(async () => {try {await writeFilePromisified(targetPath, envConfigFile);} catch (err) {console.error(err);throw err;}})();
Restart your Angular development server to re-generate the src/environments/environment.ts
file:
npm start
You are now including an audience
property in the authorizationParams
configuration object you pass to the AuthModule.forRoot()
method. Recall that the AuthModule
method initializes the authentication module system.
What about using scopes?
A property that you are not configuring directly in the AuthModule.forRoot()
method is the scope
property. When you don't pass a scope
option to Auth0 Angular SDK, which powers Auth0Plugin
, the SDK defaults to using the OpenID Connect Scopes: openid profile email
.
-
openid
: This scope informs the Auth0 Authorization Server that the Client is making an OpenID Connect (OIDC) request to verify the user's identity. OpenID Connect is an authentication protocol. -
profile
: This scope value requests access to the user's default profile information, such asname
,nickname
, andpicture
. -
email
: This scope value requests access to theemail
andemail_verified
information.
The details of the OpenID Connect Scopes go into the ID Token. However, you can define custom API scopes to implement access control. You'll identify those custom scopes in the calls that your client applications make to that API. Auth0 includes API scopes in the access token as the scope
claim value.
The Auth0 Angular SDK provides an HttpInjector
that automatically attaches access tokens to outgoing requests when using the built-in Angular HttpClient
module. However, you must configure the injector to know to which requests it needs to attach access tokens.
Update the configuration of the AuthModule
present in the imports
array of AppModule
and add the AuthHttpInterceptor
to the providers
array as follows:
import { NgModule } from '@angular/core';import { HTTP_INTERCEPTORS, HttpClientModule } from '@angular/common/http';import { BrowserModule } from '@angular/platform-browser';import { AuthHttpInterceptor, AuthModule } from '@auth0/auth0-angular';import { environment as env } from '../environments/environment';import { AppRoutingModule } from './app-routing.module';import { AppComponent } from './app.component';import { SharedModule } from './shared/shared.module';@NgModule({declarations: [AppComponent],imports: [BrowserModule,AppRoutingModule,HttpClientModule,SharedModule,AuthModule.forRoot({...env.auth0,httpInterceptor: {allowedList: [`${env.api.serverUrl}/api/messages/admin`, `${env.api.serverUrl}/api/messages/protected`],},}),],providers: [{provide: HTTP_INTERCEPTORS,useClass: AuthHttpInterceptor,multi: true,},],bootstrap: [AppComponent],})export class AppModule {}
Let's break down what is happening in the above code:
First, you are importing AuthHttpInterceptor
from @auth0/auth0-angular
along with HTTP_INTERCEPTORS
from @angular/common/http
. HTTP_INTERCEPTORS
is a multi-provider token that represents the array of registered HttpInterceptor
objects.
Next, you are adding the providers
property to the configuration object of AppModule
as follows to register the AuthHttpInterceptor
injector as a provider:
providers: [{provide: HTTP_INTERCEPTORS,useClass: AuthHttpInterceptor,multi: true,},],
This completes the wiring needed to connect the AuthHttpInterceptor
with your Angular application request cycle.
Now, you need to tell the SDK which requests to attach access tokens by configuring AuthModule.forRoot()
. Based on that configuration, Angular will match the URL of any request that you make using HttpClient
against an allowed list of URLs:
httpInterceptor: {allowedList: [`${env.api.serverUrl}/api/messages/admin`, `${env.api.serverUrl}/api/messages/protected`],},
If there's a match, Angular attaches an access token to the request's authorization header. You can use a string or a regular expression for the URL matching. For now, you are allowing Angular to attach an access token to requests it makes to http://localhost:6060/api/messages/protected
and http://localhost:6060/api/messages/admin
.
That's all it takes to integrate Angular with an external API server that is also secured by Auth0 and to use an access token to consume protected server resources from your Angular client application.
Next Steps
You have implemented user authentication in Angular to identify your users, get user profile information, and control the content that your users can access by protecting routes and API resources.
This guide covered the most common authentication use case for an Angular application: simple login and logout. However, Auth0 is an extensible and flexible identity platform that can help you achieve even more. If you have a more complex use case, check out the Auth0 Architecture Scenarios to learn more about the typical architecture scenarios we have identified when working with customers on implementing Auth0.
We'll cover advanced authentication patterns and tooling in future guides, such as using a pop-up instead of redirecting users to log in, adding permissions to ID tokens, using metadata to enhance user profiles, and much more.